platform.apiLevel = '1.0'

local screen=platform.window
local dispX=screen:width()
local dispY=screen:height()

local X=1
local Y=1
size=5
local levelOn=0
local firstTime=true
local redEnabled=false
local blueEnabled=false
local greenEnabled=false
local yellowEnabled=false
local orangeEnabled=false
local whiteEnabled=false
local darkRedEnabled=false
local lightBlueEnabled=false
local darkGreenEnabled=false
local greyEnabled=false
local pinkEnabled=false
local violetEnabled=false
local lightRedEnabled=false
local mahoganyEnabled=false
local peachEnabled=false
local darkGreyEnabled=false
local lightGreyEnabled=false
local currentFlowPack={10, {5, "1,0,5,0,7 0,0,3,0,9 0,0,0,0,0 0,5,0,7,0 0,1,3,9,0"}, {5, "7,0,0,3,1 0,0,0,5,0 0,0,5,1,0 0,0,0,0,0 0,0,0,7,3"}, {5, "0,7,3,5,0 0,0,0,1,0 0,0,1,0,0 7,0,0,9,0 3,0,9,5,0"}, {5, "0,0,0,1,5 1,0,0,0,0 0,0,7,0,0 0,0,0,3,0 5,3,7,0,0"}, {5, "0,0,0,1,5 0,7,3,5,0 0,0,0,0,0 0,0,0,0,3 0,0,1,0,7"}, {5, "7,0,3,1,5 0,0,0,0,0 0,0,0,5,0 0,3,0,0,1 0,0,0,0,7"}, {5, "3,0,0,7,0 5,0,0,0,0 7,0,5,3,0 0,1,0,1,0 0,0,0,0,0"}, {5, "3,0,0,1,9 0,0,0,7,0 0,0,7,0,0 0,1,9,0,5 0,3,5,0,0"}, {5, "0,0,0,1,0 0,7,3,5,0 0,0,7,0,0 0,0,0,0,0 3,5,1,0,0"}, {5, "0,0,0,0,0 5,0,0,1,0 3,1,3,7,0 0,0,0,0,0 7,0,0,0,5"}}
local currentFlow={{1, 0, 5, 0, 7},
                      {0, 0, 3, 0, 9},
                      {0, 0, 0, 0, 0},
                      {0, 5, 0, 7, 0},
                      {0, 1, 3, 9, 0}}--first number is size. Each flow has a type

local currentFlowStats={current={}, red={lineNum=2, amountPoints=0, x, y, points={}, endX, endY}, green={lineNum=6, amountPoints=0, x,y, points={}, endX, endY}, blue={lineNum=4, amountPoints=0, x,y, points={}, endX, endY}, yellow={lineNum=8, amountPoints=0, x,y, points={}, endX, endY}, orange={lineNum=10, amountPoints=0, x,y, points={}, endX, endY}, lightBlue={lineNum=12, amountPoints=0, x,y, points={}, endX, endY}, darkRed={lineNum=14, amountPoints=0, x,y, points={}, endX, endY}, darkGreen={lineNum=16, amountPoints=0, x,y, points={}, endX, endY}, pink={lineNum=18, amountPoints=0, x,y, points={}, endX, endY}, violet={lineNum=20, amountPoints=0, x,y, points={}, endX, endY}, grey={lineNum=22, amountPoints=0, x,y, points={}, endX, endY}, white={lineNum=24, amountPoints=0, x,y, points={}, endX, endY}, lightRed={lineNum=26, amountPoints=0, x,y, points={}, endX, endY}, mahogany={lineNum=28, amountPoints=0, x,y, points={}, endX, endY}, peach={lineNum=30, amountPoints=0, x,y, points={}, endX, endY}, darkGrey={lineNum=32, amountPoints=0, x,y, points={}, endX, endY}, lightGrey={lineNum=34, amountPoints=0, x,y, points={}, endX, endY}}
local mainMenu=false
local levelSelect=false
local paused=false
local homeScreen=false
local helpScreen=false
local settingsScreen=false

local circRatio=0.75
local lineRatio=0.5
local boardWidth=screen:height()-10
local boardHeight=screen:height()-10
local startX=screen:width()/2-boardWidth/2
local startY=5
local squareSize=boardHeight/size

local flowing=false
local flowingX=0
local flowingY=0

local homeScreenStrings={4, "Play", "Help", "Settings"}
local hlpInfo="Help and Controls for Flow\nFlow is a color connecting game. The rules and goal are simple: fill the screen by connecting all pairs of dots of the same color.\nThe controls are as follow:\n	click the arrow keys to move the cursor(up key moves up, etc.)\n	click on a dot to start a new line and move the arrow keys and click on the end dot of the same color to connect the two. This will delete your old line connecting the dots if you start a new one.\n	press clear(cntr+delete) to go back to the homescreen\n	press the arrow keys and the mouse click button to go through menus\n	to change the settings press left or right arrow keys\n\n-----------Author Info-----------\nThis is a game programmed by me, Andrew Krapivin.\nMy ti calc username is semiprocoder.\nThanks so much to Jonbush on cemetech, who gave me all the levels in this game currently.\nEmail me at andyhsstudent@gmail.com if you want to contact me."
local dispHelp=D2Editor.newRichText()
local numColors=8--constant

local backgroundColor=8--element num in array, not actuall color value. White
local boardColor=1--black
local numColor=1--black
local cursorColor=2--red
local Colors={{"white",0xffffff}, {"red", 0xff0000},{"dark red", 0x7f0000}, {"green",0x00ff00}, {"dark green", 0x007f00}, {"blue", 0x0000ff}, {"dark blue",0x00007f}, {"black", 0x000000}}
local settingsNames={5, "background color: ", "board color: ", "text/number color: ", "cursor color: "}
local settingsNamesCpy={}

local floor=math.floor


function centerText(gc, text, midX, midY)
	gc:drawString(text, midX-gc:getStringWidth(text)/2, midY+gc:getStringHeight(text)/2)
end

function drawNumsBoard(gc, sBX, sBY, sX, sY, bW, bH)--sB-sizeBoard, sX-startX, sY-startY, bW-boardWidth, bH-boardHeight
	local sizeRectX=bW/sBX
	local sizeRectY=bH/sBY
	gc:setColorRGB(Colors[boardColor][2])
    for i=0, sBY do
        gc:drawLine(sX, sY+sizeRectY*i, sX+bW, sY+sizeRectY*i)
    end
	for i=0, sBX do
		gc:drawLine(sX+sizeRectX*i, sY, sX+sizeRectX*i, sY+bH)
	end
	gc:setColorRGB(Colors[numColor][2])
	for i=1, sBY do
		for j=1, sBX do
			centerText(gc, tostring((i-1)*sBX+j), sX+sizeRectX*(j-1/2), sY+squareSize*(i-1/2))
		end
	end
	gc:setColorRGB(Colors[cursorColor][2])
	gc:drawRect(sX+X*sizeRectX, sY+Y*sizeRectY, sizeRectX, sizeRectY)
	gc:setColorRGB(0x000000)
end

function setLevel(flow, flowSize)
	redEnabled=false
	blueEnabled=false
	greenEnabled=false
	yellowEnabled=false
	orangeEnabled=false
	whiteEnabled=false
	darkRedEnabled=false
	lightBlueEnabled=false
	darkRedEnabled=false
	darkGreenEnabled=false
	greyEnabled=false
	pinkEnabled=false
	violetEnabled=false
	lightRedEnabled=false
	mahoganyEnabled=false
	peachEnabled=false
	darkGreenEnabled=false
	lightGreyEnabled=false
    size=flowSize
    squareSize=boardHeight/size
    goodFlow=flow
    currentFlow={}
    for i=1,size do
        currentFlow[i]={}
        for j=1,size do
            eye=i
            jay=j
            currentFlow[i][j]=flow[i][j]
			if flow[i][j]==1 then
				redEnabled=true
			elseif flow[i][j]==3 then
				blueEnabled=true
			elseif flow[i][j]==5 then
				greenEnabled=true
			elseif flow[i][j]==7 then
				yellowEnabled=true
			elseif flow[i][j]==9 then
				orangeEnabled=true
			elseif flow[i][j]==11 then
				lightBlueEnabled=true
			elseif flow[i][j]==13 then
				darkRedEnabled=true
			elseif flow[i][j]==15 then
				darkGreenEnabled=true
			elseif flow[i][j]==17 then
				pinkEnabled=true
			elseif flow[i][j]==19 then
				violetEnabled=true
			elseif flow[i][j]==21 then
				greyEnabled=true
			elseif flow[i][j]==23 then
				whiteEnabled=true
			elseif flow[i][j]==25 then
				lightRedEnabled=true
			elseif flow[i][j]==27 then
				mahoganyEnabled=true
			elseif flow[i][j]==29 then
				peach=true
			elseif flow[i][j]==31 then
				darkGrey=true
			elseif flow[i][j]==33 then
				lightGreyEnabled=true
			end
        end
    end
    mainMenu=false
    paused=false
    levelEditor=false
    levelSelect=false
    levelPackSelect=false
	homeScreen=false
	helpScreen=false
	settingScreen=false
    screen:invalidate()
end

function goToHome()
	levelSelect=false
	paused=false
	mainMenu=false
	helpScreen=false
	settingsScreen=false
	homeScreen=true
	X=0
	Y=0
	dispHelp:setFocus(false)
	dispHelp:setVisible(false)
	screen:invalidate()
end

function nextLevel()
	levelOn=levelOn+1
	if levelOn<=currentFlowPack[1] then
		local tempStr=currentFlowPack[levelOn+1][2]
		local tempSize=currentFlowPack[levelOn+1][1]
		arrFlowStr=string.split(tempStr, " ")
		arrFlowStr2={}
		for i=1, tempSize do
			arrFlowStr2[i]=string.split(arrFlowStr[i], ",")
			for j=1, tempSize do
				arrFlowStr2[i][j]=tonumber(arrFlowStr2[i][j])
			end
		end
		currentFlowStats.red.points=nil
		currentFlowStats.blue.points=nil
		currentFlowStats.green.points=nil
		currentFlowStats.yellow.points=nil
		currentFlowStats.orange.points=nil
		currentFlowStats.lightBlue.points=nil
		currentFlowStats.darkRed.points=nil
		currentFlowStats.darkGreen.points=nil
		currentFlowStats.pink.points=nil
		currentFlowStats.violet.points=nil
		currentFlowStats.grey.points=nil
		currentFlowStats.white.points=nil
		currentFlowStats.lightRed.points=nil
		currentFlowStats.mahogany.points=nil
		currentFlowStats.peach.points=nil
		currentFlowStats.darkGrey.points=nil
		currentFlowStats.lightGrey.points=nil
		setLevel(arrFlowStr2, tempSize)
	else
		goToHome()
	end
	screen:invalidate()
end

function on.clearKey()
	goToHome()
end

function on.activate()
    if firstTime then
		levelOn=0
		--nextLevel()
		firstTime=false
		mainMenu=false
		levelSelect=false
		helpScreen=false
		paused=false
		dispHelp:setVisible(false)
		homeScreen=true
		--help screen
		dispHelp:move(0,0)
		dispHelp:setBorder(0)
		dispHelp:setReadOnly(true)
		dispHelp:setText(hlpInfo, 1)
		dispHelp:resize(318, 212)
		dispHelp:setVisible(false)
		screen:invalidate()
	end
end

function tDrawLine(gc, x1, y1, x2, y2, thickness)
	if x1>x2 then
		local tempx1=x1
		x1=x2
		x2=tempx1
	end
	if y1>y2 then
		local tempy1=y1
		y1=y2
		y2=tempy1
	end
	if x2-x1>y2-y1 then
		gc:fillRect(x1, y1, x2-x1, thickness)
	else
		gc:fillRect(x1, y1, thickness, y2-y1)
	end
end

function drawBoard(gc)
    gc:setColorRGB(Colors[boardColor][2])
    for i=0, size do
        gc:drawLine(startX, startY+i*boardHeight/size, startX+boardWidth, startY+i*boardHeight/size)
        gc:drawLine(startX+boardWidth*i/size, startY, startX+boardWidth*i/size, startY+boardHeight)
    end
    gc:setColorRGB(Colors[cursorColor][2])
    if flowing then
        gc:setColorRGB(0x7F0000)
    end
    gc:drawRect(startX+(X-1)*boardWidth/size, startY+(Y-1)*boardHeight/size, boardWidth/size, boardHeight/size)
    for i=0,size-1 do
        for j=0,size-1 do
            if currentFlow[i+1][j+1]%2==1 and currentFlow[i+1][j+1]~=0 then
                if currentFlow[i+1][j+1]==1 then
                    gc:setColorRGB(0xFF0000)
                elseif currentFlow[i+1][j+1]==3 then
                    gc:setColorRGB(0x0000FF)
                elseif currentFlow[i+1][j+1]==5 then
                    gc:setColorRGB(0x00FF00)
                elseif currentFlow[i+1][j+1]==7 then
                    gc:setColorRGB(0xFFFF00)
                elseif currentFlow[i+1][j+1]==9 then
                    gc:setColorRGB(0xFF7F00)
				elseif currentFlow[i+1][j+1]==11 then
                    gc:setColorRGB(0x00FFFF)
				elseif currentFlow[i+1][j+1]==13 then
                    gc:setColorRGB(0x7F0000)
				elseif currentFlow[i+1][j+1]==15 then
                    gc:setColorRGB(0x007F00)
				elseif currentFlow[i+1][j+1]==17 then
                    gc:setColorRGB(0xFF207F)
				elseif currentFlow[i+1][j+1]==19 then
                    gc:setColorRGB(0x7F0F7F)
				elseif currentFlow[i+1][j+1]==21 then
                    gc:setColorRGB(0x7F7F7F)
				elseif currentFlow[i+1][j+1]==23 then
                    gc:setColorRGB(0xFFFFFF)
				elseif currentFlow[i+1][j+1]==25 then
                    gc:setColorRGB(0xFF3F3F)
				elseif currentFlow[i+1][j+1]==27 then
                    gc:setColorRGB(0x570710)
				elseif currentFlow[i+1][j+1]==29 then
                    gc:setColorRGB(0xFFD6BF)
				elseif currentFlow[i+1][j+1]==31 then
                    gc:setColorRGB(0x3F3F3F)
				elseif currentFlow[i+1][j+1]==33 then
                    gc:setColorRGB(0xAFAFAF)
				end
                gc:fillArc(startX+boardWidth/size*i+(squareSize*(1-circRatio))/2, startY+boardHeight/size*j+(squareSize*(1-circRatio))/2, squareSize*circRatio, squareSize*circRatio, 0, 360)
            end
        end
    end
	if currentFlowStats.red.points~=nil then
		local amountPoints=currentFlowStats.red.amountPoints
		gc:setColorRGB(0xFF0000)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.red.x>currentFlowStats.red.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.red.y>currentFlowStats.red.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.red.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.red.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.red.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.red.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.red.points[i-1].x>currentFlowStats.red.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.red.points[i-1].y>currentFlowStats.red.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.red.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.red.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.red.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.red.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.green.points~=nil then
		local amountPoints=currentFlowStats.green.amountPoints
		gc:setColorRGB(0x00FF00)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.green.x>currentFlowStats.green.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.green.y>currentFlowStats.green.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.green.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.green.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.green.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.green.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
		  local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.green.points[i-1].x>currentFlowStats.green.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.green.points[i-1].y>currentFlowStats.green.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.green.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.green.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.green.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.green.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.blue.points~=nil then
		local amountPoints=currentFlowStats.blue.amountPoints
		gc:setColorRGB(0x0000FF)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.blue.x>currentFlowStats.blue.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.blue.y>currentFlowStats.blue.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.blue.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.blue.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.blue.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.blue.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
		  local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.blue.points[i-1].x>currentFlowStats.blue.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.blue.points[i-1].y>currentFlowStats.blue.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.blue.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.blue.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.blue.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.blue.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.yellow.points~=nil then
		local amountPoints=currentFlowStats.yellow.amountPoints
		gc:setColorRGB(0xFFFF00)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.yellow.x>currentFlowStats.yellow.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.yellow.y>currentFlowStats.yellow.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.yellow.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.yellow.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.yellow.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.yellow.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
		  local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.yellow.points[i-1].x>currentFlowStats.yellow.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.yellow.points[i-1].y>currentFlowStats.yellow.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.yellow.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.yellow.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.yellow.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.yellow.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.orange.points~=nil then
		local amountPoints=currentFlowStats.orange.amountPoints
		gc:setColorRGB(0xFF7F00)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.orange.x>currentFlowStats.orange.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.orange.y>currentFlowStats.orange.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.orange.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.orange.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.orange.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.orange.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.orange.points[i-1].x>currentFlowStats.orange.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.orange.points[i-1].y>currentFlowStats.orange.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.orange.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.orange.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.orange.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.orange.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.lightBlue.points~=nil then
		local amountPoints=currentFlowStats.lightBlue.amountPoints
		gc:setColorRGB(0x00FFFF)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.lightBlue.x>currentFlowStats.lightBlue.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.lightBlue.y>currentFlowStats.lightBlue.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.lightBlue.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.lightBlue.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.lightBlue.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.lightBlue.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.lightBlue.points[i-1].x>currentFlowStats.lightBlue.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.lightBlue.points[i-1].y>currentFlowStats.lightBlue.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.lightBlue.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.lightBlue.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.lightBlue.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.lightBlue.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.darkRed.points~=nil then
		local amountPoints=currentFlowStats.darkRed.amountPoints
		gc:setColorRGB(0x7F0000)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.darkRed.x>currentFlowStats.darkRed.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.darkRed.y>currentFlowStats.darkRed.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.darkRed.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.darkRed.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.darkRed.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.darkRed.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.darkRed.points[i-1].x>currentFlowStats.darkRed.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.darkRed.points[i-1].y>currentFlowStats.darkRed.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.darkRed.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.darkRed.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.darkRed.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.darkRed.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.darkGreen.points~=nil then
		local amountPoints=currentFlowStats.darkGreen.amountPoints
		gc:setColorRGB(0x007F00)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.darkGreen.x>currentFlowStats.darkGreen.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.darkGreen.y>currentFlowStats.darkGreen.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.darkGreen.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.darkGreen.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.darkGreen.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.darkGreen.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.darkGreen.points[i-1].x>currentFlowStats.darkGreen.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.darkGreen.points[i-1].y>currentFlowStats.darkGreen.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.darkGreen.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.darkGreen.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.darkGreen.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.darkGreen.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.pink.points~=nil then
		local amountPoints=currentFlowStats.pink.amountPoints
		gc:setColorRGB(0xFF207F)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.pink.x>currentFlowStats.pink.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.pink.y>currentFlowStats.pink.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.pink.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.pink.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.pink.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.pink.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.pink.points[i-1].x>currentFlowStats.pink.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.pink.points[i-1].y>currentFlowStats.pink.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.pink.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.pink.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.pink.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.pink.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.violet.points~=nil then
		local amountPoints=currentFlowStats.violet.amountPoints
		gc:setColorRGB(0x7F0F7F)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.violet.x>currentFlowStats.violet.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.violet.y>currentFlowStats.violet.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.violet.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.violet.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.violet.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.violet.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.violet.points[i-1].x>currentFlowStats.violet.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.violet.points[i-1].y>currentFlowStats.violet.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.violet.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.violet.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.violet.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.violet.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.grey.points~=nil then
		local amountPoints=currentFlowStats.grey.amountPoints
		gc:setColorRGB(0x7F7F7F)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.grey.x>currentFlowStats.grey.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.grey.y>currentFlowStats.grey.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.grey.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.grey.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.grey.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.grey.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.grey.points[i-1].x>currentFlowStats.grey.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.grey.points[i-1].y>currentFlowStats.grey.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.grey.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.grey.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.grey.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.grey.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.white.points~=nil then
		local amountPoints=currentFlowStats.white.amountPoints
		gc:setColorRGB(0xFFFFFF)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.white.x>currentFlowStats.white.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.white.y>currentFlowStats.white.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.white.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.white.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.white.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.white.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.white.points[i-1].x>currentFlowStats.white.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.white.points[i-1].y>currentFlowStats.white.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.white.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.white.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.white.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.white.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.lightRed.points~=nil then
		local amountPoints=currentFlowStats.lightRed.amountPoints
		gc:setColorRGB(0xFF3F3F)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.lightRed.x>currentFlowStats.lightRed.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.lightRed.y>currentFlowStats.lightRed.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.lightRed.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.lightRed.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.lightRed.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.lightRed.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.lightRed.points[i-1].x>currentFlowStats.lightRed.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.lightRed.points[i-1].y>currentFlowStats.lightRed.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.lightRed.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.lightRed.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.lightRed.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.lightRed.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.mahogany.points~=nil then
		local amountPoints=currentFlowStats.mahogany.amountPoints
		gc:setColorRGB(0x570710)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.mahogany.x>currentFlowStats.mahogany.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.mahogany.y>currentFlowStats.mahogany.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.mahogany.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.mahogany.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.mahogany.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.mahogany.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.mahogany.points[i-1].x>currentFlowStats.mahogany.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.mahogany.points[i-1].y>currentFlowStats.mahogany.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.mahogany.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.mahogany.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.mahogany.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.mahogany.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.peach.points~=nil then
		local amountPoints=currentFlowStats.peach.amountPoints
		gc:setColorRGB(0xFFD6BF)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.peach.x>currentFlowStats.peach.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.peach.y>currentFlowStats.peach.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.peach.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.peach.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.peach.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.peach.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.peach.points[i-1].x>currentFlowStats.peach.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.peach.points[i-1].y>currentFlowStats.peach.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.peach.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.peach.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.peach.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.peach.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.darkGrey.points~=nil then
		local amountPoints=currentFlowStats.darkGrey.amountPoints
		gc:setColorRGB(0x3F3F3F)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.darkGrey.x>currentFlowStats.darkGrey.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.darkGrey.y>currentFlowStats.darkGrey.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.darkGrey.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.darkGrey.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.darkGrey.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.darkGrey.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.darkGrey.points[i-1].x>currentFlowStats.darkGrey.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.darkGrey.points[i-1].y>currentFlowStats.darkGrey.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.darkGrey.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.darkGrey.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.darkGrey.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.darkGrey.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
	if currentFlowStats.lightGrey.points~=nil then
		local amountPoints=currentFlowStats.lightGrey.amountPoints
		gc:setColorRGB(0xAFAFAF)
		if amountPoints>0 then
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.lightGrey.x>currentFlowStats.lightGrey.points[1].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.lightGrey.y>currentFlowStats.lightGrey.points[1].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
			tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.lightGrey.x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.lightGrey.y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.lightGrey.points[1].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.lightGrey.points[1].y-1)+amountAddY2, squareSize*lineRatio)
		end
	   for i=2, amountPoints do
			local amountAddX1=squareSize/2
			local amountAddX2=squareSize*3/2
			local amountAddY1=squareSize/2
			local amountAddY2=squareSize*3/2
			if currentFlowStats.lightGrey.points[i-1].x>currentFlowStats.lightGrey.points[i].x then
				amountAddX1=amountAddX1*3
				amountAddX2=amountAddX2/3
			end
			if currentFlowStats.lightGrey.points[i-1].y>currentFlowStats.lightGrey.points[i].y then
				amountAddY1=amountAddY1*3
				amountAddY2=amountAddY2/3
			end
			amountAddX1=amountAddX1*(1-lineRatio)
			amountAddY1=amountAddY1*(1-lineRatio)
			amountAddX2=amountAddX2*lineRatio
			amountAddY2=amountAddY2*lineRatio
		  tDrawLine(gc, startX+boardWidth/size*(currentFlowStats.lightGrey.points[i-1].x-1)+amountAddX1, startY+boardWidth/size*(currentFlowStats.lightGrey.points[i-1].y-1)+amountAddY1, startX+boardWidth/size*(currentFlowStats.lightGrey.points[i].x-1)+amountAddX2, startY+boardWidth/size*(currentFlowStats.lightGrey.points[i].y-1)+amountAddY2, squareSize*lineRatio)
	   end
	end
end



function updateFlow()
    if flowing then        
        if currentFlow[X][Y]==0 and currentFlowStats.current~=nil and currentFlowStats.current.amountPoints~=nil then
			currentFlowStats.current.amountPoints=currentFlowStats.current.amountPoints+1
			local prevX=currentFlowStats.current.x
			local prevY=currentFlowStats.current.y
			local amountPoints=currentFlowStats.current.amountPoints
			if currentFlowStats.current.points==nil then
				amountPoints=0
				currentFlowStats.current.points={}
			end
			if amountPoints>1 then
				prevX=currentFlowStats.current.points[amountPoints-1].x
				prevY=currentFlowStats.current.points[amountPoints-1].y
			end
			if ((prevX==X-1 or prevX==X+1) and prevY==Y) or ((prevY==Y-1 or prevY==Y+1) and prevX==X) then
				currentFlowStats.current.points[currentFlowStats.current.amountPoints]={x=X, y=Y}
				currentFlow[X][Y]=currentFlowStats.current.lineNum
			else
				for i=1,currentFlowStats.current.amountPoints-1 do
					if currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]==currentFlowStats.current.lineNum then--crashes. I assume that from the previous level the x and y remains and it overflows the current flow. To fix easily probably have to revamp entire code.
						if currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]==currentFlowStats.current.lineNum then
							currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]=0
						end
					end
				end
				currentFlowStats.current.points=nil
				currentFlowStats.endX=0
				currentFlowStats.endY=0
				currentFlowStats.current.amountPoints=0
				if flowing then
				    flowing=false
				end
			end	
		end
    end
end


function on.arrowLeft()
	if settingsScreen then
		if Y==0 then
			if backgroundColor>1 then--much easier done if I have an array but screw it
				backgroundColofeawr=backgroundColor-1
			else
				backgroundColor=numColors
			end
		elseif Y==1 then
			if boardColor>1 then--much easier done if I have an array but screw it
				boardColor=boardColor-1
			else
				boardColor=numColors
			end
		elseif Y==2 then
			if numColor>1 then--much easier done if I have an array but screw it, also I should name this something different
				numColor=numColor-1
			else
				numColor=numColors
			end
		else
			if cursorColor>1 then--much easier done if I have an array but screw it
				cursorColor=cursorColor-1
			else
				cursorColor=numColors
			end
		end
	elseif helpScreen then
	elseif levelSelect then
	   if X>0 then
	       X=X-1
	   else
	       X=9
	   end
	else
		if X>1 then
			X=X-1
			updateFlow()
		end
	end
	screen:invalidate()
end

function on.arrowRight()
	if settingsScreen then
		if Y==0 then
			if backgroundColor<numColors then--much easier done if I have an array but screw it
				backgroundColor=backgroundColor+1
			else
				backgroundColor=1
			end
		elseif Y==1 then
			if boardColor<numColors then--much easier done if I have an array but screw it
				boardColor=boardColor+1
			else
				boardColor=1
			end
		elseif Y==2 then
			if numColor<numColors then--much easier done if I have an array but screw it
				numColor=numColor+1
			else
				numColor=1
			end
		else
			if cursorColor<numColors then--much easier done if I have an array but screw it
				cursorColor=cursorColor+1
			else
				cursorColor=1
			end
		end
	elseif helpScreen then
	elseif levelSelect then
	   	if X<9 then
    		X=X+1
    	else
    	    X=0
    	end
	else
		if X<size then
			X=X+1
			updateFlow()
		end
	end
	screen:invalidate()
end

function on.arrowUp()
	if mainMenu or levelSelect or homeScreen or settingsScreen then
		if Y>levelPacks[1]-1 then
			Y=levelPacks[1]-1
		else
			if Y>0 then
				Y=Y-1
			end
		end
	elseif levelSelect then
	   if Y>0 then
	       Y=Y-1
	   end
	elseif helpScreen then
	else
		if Y>1 then
			Y=Y-1
		else
			Y=1
		end
		updateFlow()
	end
	screen:invalidate()
end

function on.arrowDown()
	if mainMenu then
		if Y<0 then
			Y=0
		else
			if Y<levelPacks[1]-1 then
				Y=Y+1
			end
		end
	elseif levelSelect then
		if Y<4 then
			Y=Y+1
		else
			Y=0
		end
	elseif homeScreen then
		if Y<homeScreenStrings[1]-2 then
			Y=Y+1
		end
	elseif settingScreen then
		if Y<settingsNames[1]-2 then
			Y=Y+1
		else
			Y=0
		end
	elseif helpScreen then
	else
		if Y<size then
			Y=Y+1
		else
			Y=size
		end
		updateFlow()
	end
	screen:invalidate()
end

function endFlow()
    if currentFlowStats.current.points~=nil then 
    if currentFlow[X][Y]==currentFlow[currentFlowStats.current.x][currentFlowStats.current.y] and (X~=currentFlowStats.current.x or Y~=currentFlowStats.current.y) then
		currentFlowStats.current.amountPoints=currentFlowStats.current.amountPoints+1
		local prevX=currentFlowStats.current.x
		local prevY=currentFlowStats.current.y
		local amountPoints=currentFlowStats.current.amountPoints
		if amountPoints>1 then
			prevX=currentFlowStats.current.points[amountPoints-1].x
			prevY=currentFlowStats.current.points[amountPoints-1].y
		end
		if ((prevX==X-1 or prevX==X+1) and prevY==Y) or ((prevY==Y-1 or prevY==Y+1) and prevX==X) then
			currentFlowStats.current.points[currentFlowStats.current.amountPoints]={x=X, y=Y}
			currentFlowStats.current.endX=X
			currentFlowStats.current.endY=Y
		else
			for i=1,currentFlowStats.current.amountPoints-1 do
				if currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]==currentFlowStats.current.lineNum then
					if currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]==currentFlowStats.current.lineNum then
						currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]=0
					end
				end
			end
			currentFlowStats.current.points=nil
			currentFlowStats.endX=0
			currentFlowStats.endY=0
			currentFlowStats.current.amountPoints=0
		end
		local win=true
		for i=1, size do 
		  for j=1, size do
			 if currentFlow[i][j]==0 then
				win=false
			 end
	       end
		end
		if redEnabled then
			if currentFlowStats.red.points~=nil and currentFlowStats.red.amountPoints>0 then
				if currentFlow[currentFlowStats.red.x][currentFlowStats.red.y]~=currentFlow[currentFlowStats.red.points[currentFlowStats.red.amountPoints].x][currentFlowStats.red.points[currentFlowStats.red.amountPoints].y] or (currentFlowStats.red.x==currentFlowStats.red.points[currentFlowStats.red.amountPoints].x and currentFlowStats.red.y==currentFlowStats.red.points[currentFlowStats.red.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if blueEnabled then
		if currentFlowStats.blue.points~=nil and currentFlowStats.blue.amountPoints>0 then
			if currentFlow[currentFlowStats.blue.x][currentFlowStats.blue.y]~=currentFlow[currentFlowStats.blue.points[currentFlowStats.blue.amountPoints].x][currentFlowStats.blue.points[currentFlowStats.blue.amountPoints].y] or (currentFlowStats.blue.x==currentFlowStats.blue.points[currentFlowStats.blue.amountPoints].x and currentFlowStats.blue.y==currentFlowStats.blue.points[currentFlowStats.blue.amountPoints].y) then
				win=false
			end
		else
			win=false
		end
		end
		if greenEnabled then
		if currentFlowStats.green.points~=nil and currentFlowStats.green.amountPoints>0 then
			if currentFlow[currentFlowStats.green.x][currentFlowStats.green.y]~=currentFlow[currentFlowStats.green.points[currentFlowStats.green.amountPoints].x][currentFlowStats.green.points[currentFlowStats.green.amountPoints].y] or (currentFlowStats.green.x==currentFlowStats.green.points[currentFlowStats.green.amountPoints].x and currentFlowStats.green.y==currentFlowStats.green.points[currentFlowStats.green.amountPoints].y) then
				win=false
			end
		else
			win=false
		end
		end
		if yellowEnabled then
		if currentFlowStats.yellow.points~=nil and currentFlowStats.yellow.amountPoints>0 then
			if currentFlow[currentFlowStats.yellow.x][currentFlowStats.yellow.y]~=currentFlow[currentFlowStats.yellow.points[currentFlowStats.yellow.amountPoints].x][currentFlowStats.yellow.points[currentFlowStats.yellow.amountPoints].y] or (currentFlowStats.yellow.x==currentFlowStats.yellow.points[currentFlowStats.yellow.amountPoints].x and currentFlowStats.yellow.y==currentFlowStats.yellow.points[currentFlowStats.yellow.amountPoints].y) then
				win=false
			end
		else
			win=false
		end
		end
		if orangeEnabled then
			if currentFlowStats.orange.points~=nil and currentFlowStats.orange.amountPoints>0 then
				if currentFlow[currentFlowStats.orange.x][currentFlowStats.orange.y]~=currentFlow[currentFlowStats.orange.points[currentFlowStats.orange.amountPoints].x][currentFlowStats.orange.points[currentFlowStats.orange.amountPoints].y] or (currentFlowStats.orange.x==currentFlowStats.orange.points[currentFlowStats.orange.amountPoints].x and currentFlowStats.orange.y==currentFlowStats.orange.points[currentFlowStats.orange.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if lightBlueEnabled then
			if currentFlowStats.lightBlue.points~=nil and currentFlowStats.lightBlue.amountPoints>0 then
				if currentFlow[currentFlowStats.lightBlue.x][currentFlowStats.lightBlue.y]~=currentFlow[currentFlowStats.lightBlue.points[currentFlowStats.lightBlue.amountPoints].x][currentFlowStats.lightBlue.points[currentFlowStats.lightBlue.amountPoints].y] or (currentFlowStats.lightBlue.x==currentFlowStats.lightBlue.points[currentFlowStats.lightBlue.amountPoints].x and currentFlowStats.lightBlue.y==currentFlowStats.lightBlue.points[currentFlowStats.lightBlue.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if darkRedEnabled then
			if currentFlowStats.darkRed.points~=nil and currentFlowStats.darkRed.amountPoints>0 then
				if currentFlow[currentFlowStats.darkRed.x][currentFlowStats.darkRed.y]~=currentFlow[currentFlowStats.darkRed.points[currentFlowStats.darkRed.amountPoints].x][currentFlowStats.darkRed.points[currentFlowStats.darkRed.amountPoints].y] or (currentFlowStats.darkRed.x==currentFlowStats.darkRed.points[currentFlowStats.darkRed.amountPoints].x and currentFlowStats.darkRed.y==currentFlowStats.darkRed.points[currentFlowStats.darkRed.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if darkGreenEnabled then
			if currentFlowStats.darkGreen.points~=nil and currentFlowStats.darkGreen.amountPoints>0 then
				if currentFlow[currentFlowStats.darkGreen.x][currentFlowStats.darkGreen.y]~=currentFlow[currentFlowStats.darkGreen.points[currentFlowStats.darkGreen.amountPoints].x][currentFlowStats.darkGreen.points[currentFlowStats.darkGreen.amountPoints].y] or (currentFlowStats.darkGreen.x==currentFlowStats.darkGreen.points[currentFlowStats.darkGreen.amountPoints].x and currentFlowStats.darkGreen.y==currentFlowStats.darkGreen.points[currentFlowStats.darkGreen.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if pinkEnabled then
			if currentFlowStats.pink.points~=nil and currentFlowStats.pink.amountPoints>0 then
				if currentFlow[currentFlowStats.pink.x][currentFlowStats.pink.y]~=currentFlow[currentFlowStats.pink.points[currentFlowStats.pink.amountPoints].x][currentFlowStats.pink.points[currentFlowStats.pink.amountPoints].y] or (currentFlowStats.pink.x==currentFlowStats.pink.points[currentFlowStats.pink.amountPoints].x and currentFlowStats.pink.y==currentFlowStats.pink.points[currentFlowStats.pink.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if violetEnabled then
			if currentFlowStats.violet.points~=nil and currentFlowStats.violet.amountPoints>0 then
				if currentFlow[currentFlowStats.violet.x][currentFlowStats.violet.y]~=currentFlow[currentFlowStats.violet.points[currentFlowStats.violet.amountPoints].x][currentFlowStats.violet.points[currentFlowStats.violet.amountPoints].y] or (currentFlowStats.violet.x==currentFlowStats.violet.points[currentFlowStats.violet.amountPoints].x and currentFlowStats.violet.y==currentFlowStats.violet.points[currentFlowStats.violet.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if greyEnabled then
			if currentFlowStats.grey.points~=nil and currentFlowStats.grey.amountPoints>0 then
				if currentFlow[currentFlowStats.grey.x][currentFlowStats.grey.y]~=currentFlow[currentFlowStats.grey.points[currentFlowStats.grey.amountPoints].x][currentFlowStats.grey.points[currentFlowStats.grey.amountPoints].y] or (currentFlowStats.grey.x==currentFlowStats.grey.points[currentFlowStats.grey.amountPoints].x and currentFlowStats.grey.y==currentFlowStats.grey.points[currentFlowStats.grey.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if whiteEnabled then
			if currentFlowStats.white.points~=nil and currentFlowStats.white.amountPoints>0 then
				if currentFlow[currentFlowStats.white.x][currentFlowStats.white.y]~=currentFlow[currentFlowStats.white.points[currentFlowStats.white.amountPoints].x][currentFlowStats.white.points[currentFlowStats.white.amountPoints].y] or (currentFlowStats.white.x==currentFlowStats.white.points[currentFlowStats.white.amountPoints].x and currentFlowStats.white.y==currentFlowStats.white.points[currentFlowStats.white.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if lightRedEnabled then
			if currentFlowStats.lightRed.points~=nil and currentFlowStats.lightRed.amountPoints>0 then
				if currentFlow[currentFlowStats.lightRed.x][currentFlowStats.lightRed.y]~=currentFlow[currentFlowStats.lightRed.points[currentFlowStats.lightRed.amountPoints].x][currentFlowStats.lightRed.points[currentFlowStats.lightRed.amountPoints].y] or (currentFlowStats.lightRed.x==currentFlowStats.lightRed.points[currentFlowStats.lightRed.amountPoints].x and currentFlowStats.lightRed.y==currentFlowStats.lightRed.points[currentFlowStats.lightRed.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if mahoganyEnabled then
			if currentFlowStats.mahogany.points~=nil and currentFlowStats.mahogany.amountPoints>0 then
				if currentFlow[currentFlowStats.mahogany.x][currentFlowStats.mahogany.y]~=currentFlow[currentFlowStats.mahogany.points[currentFlowStats.mahogany.amountPoints].x][currentFlowStats.mahogany.points[currentFlowStats.mahogany.amountPoints].y] or (currentFlowStats.mahogany.x==currentFlowStats.mahogany.points[currentFlowStats.mahogany.amountPoints].x and currentFlowStats.mahogany.y==currentFlowStats.mahogany.points[currentFlowStats.mahogany.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if peachEnabled then
			if currentFlowStats.peach.points~=nil and currentFlowStats.peach.amountPoints>0 then
				if currentFlow[currentFlowStats.peach.x][currentFlowStats.peach.y]~=currentFlow[currentFlowStats.peach.points[currentFlowStats.peach.amountPoints].x][currentFlowStats.peach.points[currentFlowStats.peach.amountPoints].y] or (currentFlowStats.peach.x==currentFlowStats.peach.points[currentFlowStats.peach.amountPoints].x and currentFlowStats.peach.y==currentFlowStats.peach.points[currentFlowStats.peach.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if darkGreyEnabled then
			if currentFlowStats.darkGrey.points~=nil and currentFlowStats.darkGrey.amountPoints>0 then
				if currentFlow[currentFlowStats.darkGrey.x][currentFlowStats.darkGrey.y]~=currentFlow[currentFlowStats.darkGrey.points[currentFlowStats.darkGrey.amountPoints].x][currentFlowStats.darkGrey.points[currentFlowStats.darkGrey.amountPoints].y] or (currentFlowStats.darkGrey.x==currentFlowStats.darkGrey.points[currentFlowStats.darkGrey.amountPoints].x and currentFlowStats.darkGrey.y==currentFlowStats.darkGrey.points[currentFlowStats.darkGrey.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		if lightGreyEnabled then
			if currentFlowStats.lightGrey.points~=nil and currentFlowStats.lightGrey.amountPoints>0 then
				if currentFlow[currentFlowStats.lightGrey.x][currentFlowStats.lightGrey.y]~=currentFlow[currentFlowStats.lightGrey.points[currentFlowStats.lightGrey.amountPoints].x][currentFlowStats.lightGrey.points[currentFlowStats.lightGrey.amountPoints].y] or (currentFlowStats.lightGrey.x==currentFlowStats.lightGrey.points[currentFlowStats.lightGrey.amountPoints].x and currentFlowStats.lightGrey.y==currentFlowStats.lightGrey.points[currentFlowStats.lightGrey.amountPoints].y) then
					win=false
				end
			else
				win=false
			end
		end
		paused=win
	else
	   for i=1,currentFlowStats.current.amountPoints do
	       if currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]==currentFlowStats.current.lineNum then
	           if currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]==currentFlowStats.current.lineNum then
	               currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]=0
	           end
	       end
	   end
	   currentFlowStats.current.points=nil
	   currentFlowStats.endX=0
	   currentFlowStats.endY=0
	   currentFlowStats.current.amountPoints=0
	end
	end
end

function enterOrMouse()
	if homeScreen then
		if Y==0 then
			mainMenu=true
		elseif Y==1 then
			helpScreen=true
		else
			settingsScreen=true
		end
		homeScreen=false
	end
	screen:invalidate()
end

function on.mouseDown()
    if (not paused) and (not mainMenu) and (not helpScreen) and (not homeScreen) and (not settingsScreen) and (not levelSelect) then
		if not flowing then
			flowing=true
			flowingX=X
			flowingY=Y
			if currentFlow[X][Y]%2==1 then
				if currentFlow[X][Y]==1 then
					currentFlowStats.current=currentFlowStats.red
				elseif currentFlow[X][Y]==3 then
					currentFlowStats.current=currentFlowStats.blue
				elseif currentFlow[X][Y]==5 then
					currentFlowStats.current=currentFlowStats.green
				elseif currentFlow[X][Y]==7 then
					currentFlowStats.current=currentFlowStats.yellow
				elseif currentFlow[X][Y]==9 then
					currentFlowStats.current=currentFlowStats.orange
				elseif currentFlow[X][Y]==11 then
					currentFlowStats.current=currentFlowStats.lightBlue
				elseif currentFlow[X][Y]==13 then
					currentFlowStats.current=currentFlowStats.darkRed
				elseif currentFlow[X][Y]==15 then
					currentFlowStats.current=currentFlowStats.darkGreen
				elseif currentFlow[X][Y]==17 then
					currentFlowStats.current=currentFlowStats.pink
				elseif currentFlow[X][Y]==19 then
					currentFlowStats.current=currentFlowStats.violet
				elseif currentFlow[X][Y]==21 then
					currentFlowStats.current=currentFlowStats.grey
				elseif currentFlow[X][Y]==23 then
					currentFlowStats.current=currentFlowStats.white
				elseif currentFlow[X][Y]==25 then
					currentFlowStats.current=currentFlowStats.lightRed
				elseif currentFlow[X][Y]==27 then
					currentFlowStats.current=currentFlowStats.mahogany
				elseif currentFlow[X][Y]==29 then
					currentFlowStats.current=currentFlowStats.peach
				elseif currentFlow[X][Y]==31 then
					currentFlowStats.current=currentFlowStats.darkGrey
				elseif currentFlow[X][Y]==33 then
					currentFlowStats.current=currentFlowStats.lightGrey
				end
				if currentFlowStats.current.points~=nil and currentFlowStats.current.amountPoints>0 then
				    for i=1, currentFlowStats.current.amountPoints do
				        if currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]~=currentFlow[currentFlowStats.current.x][currentFlowStats.current.y] then
				            currentFlow[currentFlowStats.current.points[i].x][currentFlowStats.current.points[i].y]=0
				        end
				    end
				end
				currentFlowStats.current.points={}
				currentFlowStats.current.x=X
				currentFlowStats.current.y=Y
				currentFlowStats.current.amountPoints=0
			end
		else
			endFlow()
			flowing=false
		end
    end
	if levelSelect then--doest work so disabled for now
        levelOn=10*Y+X
        X=1
        Y=1
        levelSelect=false
        flowing=false
        nextLevel()
    end
    if mainMenu then
        currentFlowPack=levelPacks.points[Y+1]
        X=0
        Y=0
        levelOn=0
        mainMenu=false
		--nextLevel()
        levelSelect=true
    end
    enterOrMouse()
    screen:invalidate()
end

function on.enterKey()
	enterOrMouse()
    if paused then
        nextLevel()
        X=1
        Y=1
		paused=false
    end
	screen:invalidate()
end

function drawMenu(gc, elements)
	local amntBrds=elements[1]-1
	local yOn=dispY/2-(amntBrds/2)*gc:getStringHeight(elements[1])
	gc:setColorRGB(Colors[numColor][2])
	for i=2, elements[1] do
		centerText(gc, elements[i], dispX/2, yOn)
		if i-2==Y then
			gc:setColorRGB(Colors[cursorColor][2])
			gc:drawRect(dispX/2-gc:getStringWidth(elements[i])/2, yOn-gc:getStringHeight(elements[i])/2, gc:getStringWidth(elements[i]), gc:getStringHeight(elements[i]))
			gc:setColorRGB(Colors[numColor][2])
		end
		yOn=yOn+gc:getStringHeight(elements[i])
	end
	gc:setColorRGB(0x000000)
end

function on.paint(gc)
	gc:setColorRGB(Colors[backgroundColor][2])
    gc:fillRect(0,0,dispX,dispY)
    gc:setColorRGB(0x000000)
	if homeScreen then
		drawMenu(gc, homeScreenStrings)
	elseif mainMenu then
		for i=0, levelPacks[1]-1 do
			gc:setColorRGB(Colors[numColor][2])
			gc:drawString(levelPacks.names[i+1], screen:width()/2-gc:getStringWidth(levelPacks.names[i+1])/2, screen:height()/2+gc:getStringHeight(levelPacks.names[i+1])/2*(3*i+2-levelPacks[1]*1.5))---(2*levelPacks[1]-3)))
			if i==Y then
				gc:setColorRGB(Colors[cursorColor][2])
			end
			gc:drawRect(screen:width()/2-gc:getStringWidth(levelPacks.names[i+1])/2, screen:height()/2+gc:getStringHeight(levelPacks.names[i+1])/2*(3*i-levelPacks[1]*1.5)--[[-(2*levelPacks[1]-1))--]], gc:getStringWidth(levelPacks.names[i+1]), gc:getStringHeight(levelPacks.names[i+1]))
		end
		gc:setColorRGB(0x000000)
	elseif helpScreen then
		dispHelp:setVisible(true)
	elseif settingsScreen then
		for i=1, settingsNames[1] do
			settingsNamesCpy[i]=settingsNames[i]
		end
		settingsNamesCpy[2]=settingsNamesCpy[2]..Colors[backgroundColor][1]
		settingsNamesCpy[3]=settingsNamesCpy[3]..Colors[boardColor][1]
		settingsNamesCpy[4]=settingsNamesCpy[4]..Colors[numColor][1]
		settingsNamesCpy[5]=settingsNamesCpy[5]..Colors[cursorColor][1]--this should all be in a single array but screw it
		drawMenu(gc, settingsNamesCpy)
	elseif levelSelect then
		drawNumsBoard(gc, 10, 5, 0, 0, dispX-1, dispY-1)
	else
		drawBoard(gc)
		gc:drawString("level: "..levelOn, 0, gc:getStringHeight("level: "..levelOn))
		if paused then
			gc:setColorRGB(Colors[numColor][2])
			gc:drawString("Next Level", screen:width()/2-gc:getStringWidth("Next Level")/2, screen:height()/2+gc:getStringHeight("Next Level")/2)--top
			gc:drawString("(press Enter to Advance)", screen:width()/2-gc:getStringWidth("(press Enter to advance)")/2, screen:height()/2+gc:getStringHeight("(press Enter to advance)")*3/2)
			gc:drawRect(screen:width()/2-gc:getStringWidth("Next Level")/2, screen:height()/2-gc:getStringHeight("Next Level")/2, gc:getStringWidth("Next Level"), gc:getStringHeight("Next Level"))
		end
	end
	--gc:drawString(currentFlowPack[2][2],0, 30)
end





levelPacks={6, names={"5 by 5 pack", "8 by 8 pack", "10 by 10 pack", "12 by 12 pack", "14 by 14 pack", "variety pack"}, 
--made by jonbush on cemetech--
------------------------------------five by five----------------------------------
points={{50, {5, "9,0,3,0,1 0,0,7,0,5 0,0,0,0,0 0,3,0,1,0 0,9,7,5,0"},
{5, "5,0,0,0,0 0,0,0,0,0 0,0,3,0,0 7,3,1,0,5 1,0,0,0,7"},
{5, "0,1,9,7,0 0,0,0,3,0 0,0,3,0,0 1,0,0,5,0 9,0,5,7,0"},
{5, "0,0,0,3,5 3,0,0,0,0 0,0,7,0,0 0,0,0,1,0 5,1,7,0,0"},
{5, "0,0,0,5,3 0,1,7,3,0 0,0,0,0,0 0,0,0,0,7 0,0,5,0,1"},
{5, "5,0,1,7,3 0,0,0,0,0 0,0,0,3,0 0,1,0,0,7 0,0,0,0,5"},
{5, "1,0,0,7,0 3,0,0,0,0 7,0,3,1,0 0,5,0,5,0 0,0,0,0,0"},
{5, "1,0,0,3,5 0,0,0,9,0 0,0,9,0,0 0,3,5,0,7 0,1,7,0,0"},
{5, "0,0,0,1,0 0,7,3,5,0 0,0,7,0,0 0,0,0,0,0 3,5,1,0,0"},
{5, "0,0,0,0,0 1,0,0,3,0 7,3,7,5,0 0,0,0,0,0 5,0,0,0,1"},
{5, "7,3,1,0,0 0,0,0,0,0 0,7,5,0,0 0,0,0,0,0 5,3,0,0,1"},
{5, "0,0,0,1,3 0,0,9,3,0 1,0,0,0,0 5,9,0,7,5 0,0,0,0,7"},
{5, "9,1,0,1,5 0,0,0,0,0 3,0,5,7,0 0,0,0,9,0 0,0,0,3,7"},
{5, "0,0,9,1,3 0,0,0,0,0 9,0,0,5,0 0,0,0,7,3 1,5,0,0,7"},
{5, "7,1,0,0,0 0,0,3,0,0 5,0,7,0,0 0,0,0,0,0 5,3,1,0,0"},
{5, "0,0,0,0,0 3,7,0,7,0 1,0,0,0,0 0,3,5,0,5 0,0,0,0,1"},
{5, "1,0,0,0,1 0,5,3,5,7 0,0,0,0,0 0,3,0,0,0 0,0,0,7,0"},
{5, "0,0,0,0,0 0,3,0,1,0 0,0,1,0,0 0,0,5,0,7 5,3,7,0,0"},
{5, "0,0,0,0,0 7,5,0,5,0 0,0,0,1,0 1,0,0,3,0 3,0,7,0,0"},
{5, "5,0,3,7,1 1,0,0,0,0 0,0,3,0,0 0,0,5,7,0 0,0,0,0,0"},
{5, "0,0,0,9,5 0,9,3,0,0 0,0,0,0,0 0,0,3,7,5 1,0,1,0,7"},
{5, "0,3,0,0,0 0,1,0,5,0 3,7,5,0,0 0,0,1,0,0 7,9,0,0,9"},
{5, "0,0,0,0,0 3,1,0,1,0 5,0,0,0,0 0,3,0,5,7 0,0,0,7,0"},
{5, "1,0,0,0,1 0,0,0,0,0 0,7,5,0,3 0,0,0,0,5 0,3,0,0,7"},
{5, "1,5,0,0,5 0,0,0,0,0 0,0,0,3,1 3,0,0,9,7 9,0,7,0,0"},
{5, "0,0,0,0,0 0,3,0,3,0 0,0,0,0,7 7,0,5,0,1 1,0,0,0,5"},
{5, "0,0,5,0,3 0,3,0,0,7 0,1,0,1,0 0,7,0,0,0 0,0,0,0,5"},
{5, "0,0,0,0,0 1,3,0,3,1 7,0,0,0,0 0,5,0,9,0 7,9,0,5,0"},
{5, "3,0,0,0,0 5,9,0,9,0 0,0,0,5,3 1,0,0,1,7 7,0,0,0,0"},
{5, "7,0,0,0,5 0,0,0,0,0 0,1,3,0,0 0,0,7,0,0 3,1,5,0,0"},
{5, "0,0,0,0,0 0,3,0,3,5 0,0,0,0,0 7,5,0,1,7 0,0,0,0,1"},
{5, "0,0,0,0,0 7,0,0,3,0 5,3,1,5,0 0,1,0,0,0 0,0,0,0,7"},
{5, "7,1,0,0,0 0,0,3,5,0 7,0,1,0,0 0,0,0,0,0 5,3,0,0,0"},
{5, "0,0,3,0,5 3,7,0,0,1 5,0,7,0,0 1,0,0,0,0 0,0,0,0,0"},
{5, "0,0,0,7,5 0,7,1,0,0 1,0,0,0,0 3,5,0,0,0 0,0,0,0,3"},
{5, "0,0,0,0,0 5,7,0,1,5 0,3,7,0,3 0,1,0,0,0 0,0,0,0,0"},
{5, "0,0,1,0,5 0,0,0,0,3 1,0,7,0,0 7,0,5,0,0 0,0,0,0,3"},
{5, "0,1,0,0,0 0,5,0,7,0 1,7,0,0,0 5,3,0,3,0 0,0,0,0,0"},
{5, "1,0,1,9,7 0,0,0,0,0 0,5,0,0,0 9,0,3,5,0 3,0,7,0,0"},
{5, "0,0,0,0,0 0,3,0,0,0 0,0,7,3,0 1,5,0,5,0 0,0,1,7,0"},
{5, "1,0,0,0,7 0,0,3,0,3 0,0,7,0,5 0,5,0,0,1 0,0,0,0,0"},
{5, "7,5,0,3,0 0,7,0,1,0 0,3,5,0,0 0,1,0,0,0 0,0,0,0,0"},
{5, "1,0,0,0,5 0,0,7,0,0 0,0,0,5,0 0,3,0,7,0 0,1,0,0,3"},
{5, "0,0,0,0,1 0,0,7,3,0 3,7,0,0,0 1,0,0,5,0 9,0,0,9,5"},
{5, "0,0,0,0,0 1,7,0,7,0 0,0,0,0,0 0,0,3,5,0 5,3,1,0,0"},
{5, "0,0,1,7,3 0,5,0,0,0 0,0,0,0,0 0,5,7,3,1 0,0,0,0,0"},
{5, "3,0,0,0,1 9,3,0,5,7 0,1,0,0,0 0,5,0,0,0 0,9,7,0,0"},
{5, "0,0,0,3,1 5,3,0,0,0 1,0,5,0,0 0,0,0,0,0 0,0,0,0,0"},
{5, "3,0,0,0,3 0,0,0,5,1 0,5,1,0,0 0,0,0,0,0 0,0,0,0,0"},
{5, "0,0,0,0,1 0,7,0,0,7 0,0,0,1,3 0,0,0,5,0 5,3,0,0,0"}}, 
------------------------------------eight by eight----------------------------------
{50, {8, "0,0,0,0,1,0,0,0 0,0,0,0,3,0,11,7 0,0,0,0,11,7,0,3 0,0,0,9,5,0,0,0 0,0,0,0,9,0,0,0 0,0,0,0,5,0,0,0 0,0,0,0,0,0,0,0 0,1,0,0,0,0,0,0"},
{8, "11,1,3,0,0,0,0,0 0,0,0,0,0,0,7,0 0,0,0,0,0,0,0,0 9,0,9,5,0,0,0,0 0,0,0,0,0,0,0,0 5,0,0,0,0,1,0,0 0,0,0,0,0,0,0,0 11,7,0,3,0,0,0,0"},
{8, "0,1,0,0,0,0,0,0 0,0,0,7,0,0,7,0 0,0,11,0,0,0,0,0 0,0,0,0,0,0,0,0 0,0,0,1,3,0,0,5 0,0,0,9,0,0,0,11 0,3,0,0,0,0,0,0 0,0,0,0,0,0,9,5"},
{8, "3,0,0,0,0,0,0,0 0,0,0,0,0,0,9,13 0,0,0,11,0,0,0,0 0,13,0,0,0,0,9,11 0,0,0,0,7,0,0,1 0,0,1,0,0,0,0,5 0,0,7,5,0,0,0,3 0,0,0,0,0,0,0,0"},
{8, "0,0,0,0,0,0,1,11 0,0,0,3,0,0,0,0 0,0,0,0,0,0,0,0 0,3,0,5,0,0,7,0 0,1,0,0,0,11,0,0 0,0,0,0,0,0,0,0 0,5,0,0,0,0,0,0 0,7,9,0,0,0,0,9"},
{8, "3,0,0,0,0,0,0,1 13,0,0,0,11,0,0,0 5,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,11 0,0,0,0,13,0,0,3 0,7,9,0,0,0,0,0 0,5,0,0,0,0,9,7"},
{8, "0,0,0,0,0,0,0,3 7,0,0,0,0,3,0,0 0,0,9,0,7,0,0,0 0,1,0,0,0,0,5,0 0,9,0,0,1,0,0,0 0,0,0,0,0,0,0,0 0,5,0,0,0,0,0,0 0,0,0,0,0,0,0,0"},
{8, "0,0,0,0,0,1,3,11 0,0,0,0,0,0,0,0 0,3,0,0,0,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,9,0,0,0 0,11,7,5,13,0,0,7 0,5,0,0,1,0,0,9 0,0,0,0,0,0,0,13"},
{8, "0,0,0,0,0,0,0,0 0,1,5,0,0,0,7,0 0,0,11,0,0,0,0,0 11,0,0,0,0,9,0,0 1,0,0,5,0,3,0,0 9,3,0,0,0,0,0,0 0,0,0,0,0,0,7,0 0,0,0,0,0,0,0,0"},
{8, "0,0,0,1,0,1,0,3 0,5,0,0,5,0,0,7 0,0,0,0,0,0,0,0 0,9,0,0,0,0,0,0 0,0,7,0,11,0,3,0 0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,9 11,0,0,0,0,0,0,0"},
{8, "0,0,0,0,0,3,7,0 0,0,0,0,0,0,13,0 0,0,0,0,3,0,0,0 0,0,0,5,0,0,13,0 0,5,0,9,0,0,0,0 0,0,0,11,0,0,9,0 0,0,0,0,0,0,11,0 7,1,0,1,0,0,0,0"},
{8, "0,1,0,0,0,0,7,0 0,0,0,0,5,0,9,0 0,0,0,0,11,0,11,0 0,9,0,0,0,0,0,0 0,0,0,0,0,0,0,3 0,0,7,0,0,3,0,0 0,0,0,0,0,0,5,0 0,0,0,0,1,0,0,0"},
{8, "11,0,0,0,0,0,0,5 0,0,0,0,0,0,0,0 0,0,0,1,0,9,0,0 0,0,0,0,0,0,7,5 0,0,0,0,9,0,0,0 0,0,7,0,0,0,11,0 1,0,0,0,3,0,3,0 0,0,0,0,0,0,0,0"},
{8, "0,0,3,0,0,0,0,0 0,0,0,0,1,0,0,0 0,0,0,0,0,7,0,0 0,0,0,1,0,0,0,0 0,0,0,0,0,0,7,9 0,0,9,5,0,0,0,0 0,0,0,0,0,0,0,0 11,0,0,0,0,11,3,5"},
{8, "0,1,0,0,0,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,3,9,0,0 0,0,0,0,0,0,5,0 0,0,0,3,11,0,0,0 0,0,0,0,0,0,0,11 0,0,9,0,0,7,0,7 0,0,0,1,0,0,0,5"},
{8, "1,0,0,0,0,0,5,1 0,0,0,0,13,0,0,0 0,0,0,0,9,0,0,0 0,0,7,0,3,0,0,0 13,0,0,0,11,0,0,0 11,0,7,0,0,0,0,0 0,0,9,3,0,0,5,0 0,0,0,0,0,0,0,0"},
{8, "7,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0 0,13,0,0,0,0,0,0 5,15,0,0,15,0,0,0 9,0,0,0,1,0,5,0 0,0,0,11,9,13,3,0 0,1,11,0,0,0,0,0 0,0,0,0,3,0,7,0"},
{8, "17,0,0,0,9,0,0,0 3,0,0,0,0,1,7,1 17,0,3,0,0,7,0,13 11,0,0,0,0,5,11,0 0,0,5,15,0,0,0,0 0,0,15,0,9,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,13"},
{8, "0,11,0,0,0,0,3,0 0,15,0,0,9,0,0,0 0,9,0,0,3,0,15,0 0,0,11,1,13,0,0,0 1,0,0,0,0,5,13,0 0,0,0,0,0,0,5,0 0,7,0,0,0,0,7,0 0,0,0,0,0,0,0,0"},
{8, "0,0,5,0,1,15,0,0 0,11,0,0,17,0,17,0 0,0,0,0,0,0,0,15 7,0,0,0,0,11,0,1 0,0,0,0,0,0,0,13 0,0,0,0,0,9,0,0 0,5,3,9,0,0,0,0 0,0,0,7,3,13,0,0"},
{8, "0,0,0,0,0,1,3,15 0,0,0,0,0,0,0,0 0,7,0,0,0,0,3,0 0,0,0,5,0,0,0,0 0,13,0,0,0,9,0,15 0,0,0,11,0,0,0,0 0,5,0,0,0,0,9,0 0,1,11,13,0,7,0,0"},
{8, "0,0,0,0,5,0,11,0 0,0,3,0,0,5,9,0 0,0,11,1,0,0,0,0 0,0,0,0,9,0,0,0 0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,0 0,3,0,0,0,0,1,0 0,7,0,0,0,0,0,0"},
{8, "3,0,0,0,0,0,0,5 0,0,9,7,5,13,0,0 0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0 0,11,0,0,0,0,0,0 0,0,0,0,1,0,0,0 0,1,0,0,3,11,7,0 0,0,0,13,0,0,0,0"},
{8, "0,13,3,0,0,0,0,0 0,3,1,0,0,0,0,0 0,0,0,1,0,5,0,0 0,9,0,11,0,0,0,0 0,0,0,0,0,5,7,0 0,0,0,0,0,7,11,0 0,0,0,0,0,0,0,0 13,9,0,0,0,0,0,0"},
{8, "7,0,0,13,0,0,0,0 0,11,0,9,5,0,0,0 0,7,0,0,0,0,0,0 0,1,0,0,0,0,0,0 0,0,0,11,0,0,0,0 0,0,0,3,0,0,0,0 3,0,0,0,0,0,5,0 1,0,9,0,0,0,13,0"},
{8, "11,0,0,0,0,0,0,0 5,7,0,15,0,0,0,0 0,0,11,0,0,13,0,0 0,7,1,0,0,0,0,0 0,0,9,0,13,0,0,0 3,0,5,0,9,1,3,0 0,0,0,0,0,0,0,0 15,0,0,0,0,0,0,0"},
{8, "0,0,0,0,0,0,0,0 0,3,0,0,0,0,0,5 0,0,0,0,0,0,0,1 0,0,0,0,13,7,0,0 0,0,0,0,0,0,0,0 0,0,13,0,0,9,0,0 0,0,7,3,9,1,0,11 0,0,0,5,11,0,0,0"},
{8, "0,0,0,0,0,0,0,0 0,0,13,3,0,0,0,1 0,0,0,0,0,5,0,0 0,13,0,9,0,0,7,0 0,11,0,0,0,0,0,0 0,9,0,0,11,0,0,0 0,5,0,0,0,0,0,0 0,0,0,1,7,0,0,3"},
{8, "0,0,0,1,0,0,0,0 0,5,0,0,0,0,11,0 0,7,0,3,0,0,0,0 0,9,0,0,0,5,0,1 0,0,0,0,0,0,0,0 0,0,7,0,0,0,0,0 0,0,0,0,9,3,11,0 0,0,0,0,0,0,0,0"},
{8, "0,0,0,0,1,3,1,0 0,0,0,0,5,0,9,0 0,0,11,0,0,0,0,0 0,0,0,0,0,3,9,0 0,0,11,13,0,0,0,0 0,0,0,0,0,7,0,0 0,13,7,5,0,0,0,0 0,0,0,0,0,0,0,0"},
{8, "3,7,0,0,0,5,0,0 0,0,0,3,0,7,15,0 1,0,0,0,0,9,0,0 0,11,0,0,0,0,0,0 0,9,1,0,0,5,0,0 0,0,0,0,0,0,11,0 0,13,0,0,13,0,15,0 0,0,0,0,0,0,0,0"},
{8, "0,0,0,0,0,0,15,7 0,0,0,0,0,0,7,0 0,0,1,0,0,0,0,5 0,0,9,0,0,0,0,1 0,0,13,0,0,0,0,3 0,0,0,11,0,11,0,0 15,0,0,3,0,9,0,0 5,0,0,13,0,0,0,0"},
{8, "1,0,1,0,0,0,0,0 5,0,0,0,0,0,3,0 15,7,0,9,3,0,13,0 0,0,0,13,0,0,0,0 0,0,0,7,0,0,0,11 0,0,0,0,5,0,0,0 0,0,0,0,0,0,9,0 0,0,0,0,0,15,11,0"},
{8, "5,0,0,0,0,5,7,0 11,0,0,0,0,0,0,0 0,0,0,0,13,1,0,0 0,11,0,0,0,0,0,0 0,9,0,0,13,1,0,0 0,0,0,0,0,3,0,0 0,9,0,0,0,0,0,0 0,3,7,0,0,0,0,0"},
{8, "0,0,0,0,1,7,0,0 1,3,0,0,0,0,0,0 7,9,0,0,5,0,3,0 0,15,0,0,0,0,0,0 0,11,0,15,0,0,0,0 0,0,13,0,13,0,0,0 0,0,0,0,11,9,5,0 0,0,0,0,0,0,0,0"},
{8, "0,0,0,0,0,0,0,0 0,7,11,0,0,0,0,0 0,0,0,0,0,0,11,9 0,0,0,0,15,0,0,0 13,9,15,1,0,0,1,0 0,0,5,3,0,0,3,0 0,5,0,0,0,0,13,0 0,0,0,7,0,0,0,0"},
{8, "0,0,0,0,0,0,3,7 0,0,0,0,0,0,0,0 0,9,0,0,0,0,9,0 0,5,0,0,1,0,0,0 0,0,0,0,0,13,0,0 0,0,3,11,0,0,0,0 0,1,0,0,13,5,7,0 0,0,0,0,0,0,0,11"},
{8, "0,0,0,9,0,0,0,9 0,1,0,0,0,0,0,0 0,0,3,0,0,7,0,0 0,0,0,0,0,5,0,0 0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,0,1,3,0 0,0,0,0,0,7,5,0"},
{8, "0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,11,3,0,0 0,5,0,0,9,0,0,0 0,0,0,0,11,0,0,7 0,0,9,0,0,0,0,1 0,0,0,0,0,3,0,0 0,0,0,0,7,5,0,1"},
{8, "3,0,0,5,13,0,0,0 5,0,0,0,0,11,7,0 9,0,0,3,0,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0 0,11,0,0,0,0,0,0 9,7,0,1,0,0,1,0 13,0,0,0,0,0,0,0"},
{8, "0,0,1,3,0,0,0,0 0,0,9,5,0,0,0,0 0,0,0,0,0,3,0,0 0,9,0,0,0,0,0,0 0,5,0,0,13,0,0,0 0,7,0,0,0,0,0,0 0,13,0,0,0,0,7,0 0,1,11,0,11,0,0,0"},
{8, "0,0,0,0,0,0,0,0 0,0,11,0,0,0,15,3 0,0,7,0,5,0,0,0 0,0,0,0,0,0,0,5 0,0,0,15,0,9,0,13 0,0,7,13,0,0,9,1 0,0,0,1,0,0,0,0 0,3,0,0,0,0,0,11"},
{8, "0,11,1,0,0,0,0,0 0,7,0,0,0,0,3,0 0,5,0,0,0,0,0,0 0,9,0,0,0,0,0,0 0,0,0,7,0,0,0,0 0,0,0,1,0,0,0,0 11,9,0,3,13,0,0,0 5,0,0,0,0,0,0,13"},
{8, "0,5,3,9,0,0,0,0 0,13,0,0,0,0,1,0 0,0,0,0,0,0,0,0 5,0,0,0,0,0,0,9 0,0,0,0,0,0,0,0 13,11,0,0,0,0,0,0 11,0,0,0,7,1,7,0 3,0,0,0,0,0,0,0"},
{8, "15,1,0,0,0,0,0,0 0,0,0,5,0,0,0,0 0,0,0,9,0,0,0,0 0,0,0,0,3,0,0,0 0,0,0,0,0,0,5,0 0,13,0,0,1,0,0,0 15,7,11,0,0,0,9,0 7,0,0,0,11,0,13,3"},
{8, "0,0,0,0,13,0,0,3 0,5,0,0,0,1,13,0 0,7,0,0,0,11,0,0 0,11,5,7,0,0,0,0 0,0,0,1,9,0,0,0 0,0,9,0,0,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,3"},
{8, "1,0,1,0,0,0,0,0 3,0,0,0,13,0,0,17 11,9,0,17,3,5,0,13 0,0,0,0,0,0,0,5 0,0,0,0,9,0,0,0 0,0,0,0,15,0,11,0 7,15,0,0,0,0,0,0 0,7,0,0,0,0,0,0"},
{8, "0,0,0,0,1,5,0,5 0,13,0,0,0,0,0,11 0,0,0,0,13,0,7,9 0,0,15,0,0,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,3,0,0,0 0,11,15,0,0,0,7,0 0,0,1,9,3,0,0,0"},
{8, "0,0,0,7,0,0,3,5 0,11,9,0,0,0,0,0 0,0,0,0,5,0,0,3 0,0,0,0,0,0,0,1 0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0 0,1,0,0,0,0,11,0 0,0,0,0,7,0,0,0"},
{8, "5,9,1,0,0,0,1,3 0,0,0,0,0,9,3,0 0,13,0,0,0,11,0,0 0,0,0,0,0,0,0,0 0,0,11,0,0,7,0,0 0,0,0,0,0,0,0,0 0,0,0,0,7,0,13,0 0,0,0,0,5,0,0,0"}},
------------------------------------ten by ten----------------------------------
{50, {10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,3,0,0 0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,5,0,0,0,0 0,0,0,1,0,0,0,0,0,5 0,0,0,0,3,0,0,0,0,7 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,7,9"},
{10, "0,0,0,0,0,0,0,3,0,0 0,0,0,0,0,9,0,7,0,0 5,0,5,0,0,0,0,11,0,0 0,0,13,0,0,0,0,0,0,0 0,0,0,0,1,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,1,0,0,0,0,0,0,0,7 0,13,0,0,0,0,0,0,0,0 0,11,0,0,0,3,0,0,0,0 0,0,0,9,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,7,0,0,0,0,0,0,9,0 0,3,9,0,0,0,0,11,0,0 0,0,0,0,0,0,0,0,0,0 0,7,0,0,3,0,1,0,0,0 0,1,5,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 11,0,0,0,0,0,0,0,0,0 5,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,7,1 0,0,0,0,11,0,0,0,0,3 0,5,0,0,3,0,0,0,0,0 0,0,0,0,5,0,0,0,0,0 0,0,9,0,0,1,0,0,0,0 0,0,0,0,0,9,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,11,0,0,7,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,1 0,0,0,0,0,5,0,0,0,11 0,0,3,0,0,0,0,0,0,9 0,0,0,0,0,0,0,0,5,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,7,0,1,0,0,0,0,9,0 0,0,0,0,0,7,0,0,0,0 0,0,0,0,0,0,0,3,11,0 0,0,0,0,0,0,0,0,0,0"},
{10, "1,0,0,0,0,3,5,0,9,0 0,0,7,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,5,3,0,9,0,0,0,0,0 0,0,0,1,0,0,0,0,0,0 0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "1,7,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,11 0,0,0,0,0,3,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,5,0,0,0,0,0 0,0,0,0,11,0,0,0,0,0 0,0,0,0,7,1,0,0,0,5 0,0,0,0,0,0,0,0,0,9 9,0,0,0,0,0,0,0,0,3"},
{10, "0,0,0,0,0,0,0,1,0,0 0,0,0,0,0,7,0,5,0,0 0,0,3,0,0,0,0,9,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,1,0,0,0,0,0,0 0,0,0,0,0,3,0,0,0,0 0,0,0,0,0,11,0,0,0,0 11,0,0,0,0,9,0,0,0,0 5,7,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,1,9 7,3,0,0,0,0,0,0,0,0 3,5,0,0,0,0,0,0,0,7 0,0,0,0,0,0,0,0,0,0 0,0,0,0,5,0,0,0,0,0 0,1,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,9,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,5,1,0,0,0,0,0,0,0 9,3,0,0,0,0,0,0,0,0 7,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,9,7,3,0,0,0 0,0,5,0,0,0,0,0,0,0 0,1,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "9,0,0,0,3,0,0,0,0,0 1,0,0,0,0,0,0,0,0,0 5,7,0,0,0,5,0,0,0,0 0,0,0,9,0,0,7,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,1 0,3,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,3,7 0,0,0,0,0,0,0,0,11,0 0,0,0,0,0,0,0,0,0,0 0,0,0,3,0,0,0,0,0,0 0,0,0,0,0,5,0,0,9,0 0,0,0,0,9,0,0,5,1,0 0,0,7,0,0,0,0,0,0,0 0,0,0,0,0,0,0,11,0,0 0,1,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "3,0,0,0,0,0,0,0,0,1 5,0,0,0,0,0,0,0,0,7 0,0,0,0,0,0,0,0,0,0 0,9,0,0,0,0,0,0,11,0 0,0,0,0,0,0,0,3,0,0 0,0,0,5,0,0,0,7,0,0 0,0,0,0,0,0,0,1,0,0 0,0,0,0,0,0,0,9,0,0 0,11,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,1,0,5 0,11,3,0,0,7,0,0,0,3 0,0,0,0,9,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,5,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,7,1,0,11,9 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,7,0,0,0,0 0,1,7,0,0,0,0,0,5,0 0,0,0,0,0,0,0,0,0,0 0,3,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0 0,0,0,13,0,0,0,0,0,0 0,0,0,0,0,3,1,0,0,0 13,0,0,0,0,0,0,0,0,0 5,0,11,9,0,0,0,0,0,11"},
{10, "0,0,0,11,0,0,0,5,3,0 0,0,0,0,0,9,0,0,1,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,9,0,5,0,0,0,0,0 0,0,11,0,0,0,13,7,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,1,0,0,0,0,0 0,13,0,0,3,0,0,0,0,0 0,0,0,0,0,0,0,0,0,7"},
{10, "11,7,0,0,0,1,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,5,0,0,0,0,0,0,0,0 3,0,0,0,0,9,0,0,0,0 0,0,0,1,0,0,0,0,0,0 0,11,0,0,0,0,3,0,0,0 0,0,5,9,0,0,0,0,0,0 0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,3,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,9,0,0,0 0,0,1,0,0,1,0,7,0,0 0,0,0,0,0,11,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,7,9,5,0,0,0,0,0 0,0,0,0,0,0,0,0,3,0 0,0,0,0,0,0,0,0,11,5"},
{10, "0,0,0,0,0,0,5,7,0,0 0,0,0,0,0,0,1,5,9,0 0,0,0,0,0,0,0,0,0,0 0,0,0,3,0,0,0,0,0,0 0,0,0,0,0,0,0,0,3,0 0,0,0,0,9,0,0,0,0,0 0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,0,0,1,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "3,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,1,0,0,0,0 0,0,0,0,0,0,0,9,5,0 0,0,0,0,0,3,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,9,0,0,0,0,0,0,0,7 0,5,0,0,0,0,0,7,0,1"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,13,9,0,0,0,0,3,0,0 0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,9,0,0,0,0 0,1,0,5,0,0,0,0,0,0 0,11,0,13,7,0,0,0,0,0 0,0,0,0,0,0,0,0,0,3 0,0,0,0,0,0,0,0,1,11 5,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,3,0 0,0,0,5,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,1,0,0,0,0,0 0,0,0,0,0,9,0,0,7,1 0,0,7,0,0,0,0,0,0,9 0,0,0,0,0,0,0,3,5,0 0,0,0,0,0,0,0,0,0,0"},
{10, "5,0,0,0,0,1,0,0,0,0 0,0,0,0,0,0,0,3,9,0 0,0,11,0,0,0,1,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,7,0,0,0,11 0,0,0,0,0,0,0,0,0,3 0,9,0,0,0,5,0,0,0,0 0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,5,13,7,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,9,0,0 0,0,0,0,0,0,0,0,0,3 0,0,0,0,0,1,0,0,0,11 0,0,0,0,7,11,0,0,0,0 0,0,13,0,9,5,3,0,0,0 0,0,0,0,0,0,0,0,1,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,11,0,0,0,0,1,3 0,7,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0 0,0,0,9,3,0,0,5,0,0 0,0,0,7,0,11,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,0,0,0 0,0,0,0,0,0,0,0,0,0 5,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,3,0,0 5,0,0,0,0,7,0,0,0,0 0,0,0,0,0,0,5,0,0,0 0,0,0,0,0,0,0,0,0,1 0,1,3,0,0,0,0,0,7,0 0,0,0,0,0,0,9,0,0,0"},
{10, "3,0,0,0,0,0,0,0,0,0 0,0,0,0,11,5,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,5,0 0,0,0,0,0,9,0,0,0,0 0,0,0,0,0,3,0,0,0,0 0,1,7,0,0,0,0,0,0,9 0,0,0,0,0,0,0,11,0,1"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,1,0,0,0,0,0,0 0,0,5,0,0,0,0,0,0,0 0,0,0,0,7,0,0,0,0,0 0,0,0,0,0,0,0,0,11,0 0,11,0,0,3,0,1,0,0,0 0,0,0,0,0,0,0,9,5,0 7,0,0,0,0,0,0,3,9,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,3,0 0,0,0,0,0,0,0,0,0,0 0,0,0,1,7,0,0,0,0,3 0,9,0,0,0,0,0,0,0,0 0,0,5,0,0,0,0,0,0,0 11,0,0,0,0,0,0,0,5,0 1,7,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,11"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,5,0 0,0,0,3,1,0,11,0,0,0 0,0,7,0,0,0,0,0,0,0 0,0,0,5,0,0,0,0,0,0 0,0,0,0,0,0,0,0,1,0 0,0,11,0,0,0,0,3,9,0 0,9,0,0,0,0,0,0,0,0 0,0,0,0,7,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,7,0,0,0,0,1,0 0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,5,9,1,0,0,0,0,0 0,11,0,0,0,0,0,3,7,0 0,0,0,0,0,5,0,11,3,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,11,0,0,0,0,0,0,0,0 0,1,7,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,5,0,0,0,0 0,0,3,0,0,0,0,0,0,0 0,0,0,0,11,7,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,5,0,0,0,9,1,0,0,0 0,9,0,0,0,0,0,0,0,3"},
{10, "1,0,0,0,0,0,0,0,0,0 0,0,3,0,0,0,0,5,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,9,0,0,0 7,0,0,0,1,0,0,0,0,0 11,0,0,0,0,0,0,0,0,0 5,0,0,0,0,11,0,0,0,0 7,0,9,0,0,0,0,3,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,7 0,1,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,5,0,7,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,3,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,3,0 0,11,9,1,0,0,0,0,0,0 0,0,0,0,0,0,0,11,5,0 0,0,0,0,9,0,0,0,0,0"},
{10, "0,0,0,0,0,11,0,0,0,0 0,0,0,0,1,0,0,0,3,5 0,0,0,0,11,0,0,0,5,9 0,0,0,0,9,0,0,0,0,0 0,0,0,0,7,0,0,0,7,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,3,0,0,0 0,0,0,0,0,0,0,0,0,0 0,1,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "1,0,0,0,0,3,0,0,0,0 0,0,0,0,0,0,0,0,5,0 0,0,9,0,0,0,0,0,7,0 0,0,0,0,0,0,0,3,9,0 0,0,0,1,0,0,0,0,0,0 0,0,0,5,0,0,0,0,0,0 0,0,0,7,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,3,0,0,0,0,0,0,0,0 0,0,0,0,0,0,11,0,0,0 11,0,0,0,0,0,0,0,0,0 1,0,0,0,0,0,5,0,0,0 9,0,0,0,0,0,3,0,7,0 7,0,5,0,0,0,0,9,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,1,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,3,0 0,0,0,0,0,1,0,0,0,0 0,0,0,0,0,0,0,9,0,0 0,0,0,0,5,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,7,5,0 0,0,0,0,0,0,0,3,7,0 0,0,0,0,0,0,0,0,0,0 9,0,0,0,0,0,0,0,0,0"},
{10, "11,3,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 5,0,0,0,0,0,0,9,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,7,13,0,0,11,0 0,0,1,0,0,0,0,0,0,0 0,0,0,0,9,0,0,5,0,0 0,0,0,0,0,0,0,3,0,0 13,7,0,0,0,0,0,0,0,0 1,0,0,0,0,0,0,0,0,0"},
{10, "0,0,1,5,0,0,0,0,0,0 0,0,13,3,9,0,0,5,11,0 0,0,0,0,0,0,1,0,0,0 0,0,0,7,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,11,0,0,9,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,3,0,0,7,13,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,5,3,0,0 0,0,0,0,0,0,0,0,1,0 0,0,0,0,0,0,0,0,5,0 0,0,0,9,0,0,0,0,0,0 0,0,0,0,0,3,0,0,0,0 0,0,0,0,0,7,9,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,1,0,0,7,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,5,3,1,0,7,0,0,0,0 0,9,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 9,0,0,0,0,5,0,0,0,0 0,0,0,0,0,11,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,7,1,3,0,0,0,0 0,11,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "1,0,0,0,0,0,0,0,0,0 0,11,7,3,0,0,0,0,0,0 0,5,0,0,0,0,0,9,0,0 0,0,0,0,0,0,0,0,0,0 0,0,11,0,1,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,3,0,0,7,0,0,0,0 0,0,5,0,9,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,9,1,13,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,3,0,0,0,0 0,0,0,0,0,5,13,7,0,0 0,0,0,0,0,11,5,0,0,0 7,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,1,0,0,0,0,3,0,11,0 0,0,0,0,0,0,9,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 0,1,7,0,0,0,15,0,0,0 0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,0,0,0 0,0,5,0,3,0,0,0,0,0 0,11,9,0,9,0,0,0,0,0 0,0,0,0,13,0,0,0,15,13 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,11,0,0,3,0 0,0,0,0,0,0,0,5,1,0"},
{10, "0,0,0,0,0,0,0,0,0,1 3,0,0,0,0,0,11,0,0,5 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,5,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,7,0,9,3,0,0 0,0,7,0,0,1,0,0,0,0 0,0,0,9,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,11"},
{10, "3,0,1,0,0,0,5,0,0,1 9,0,7,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,11,0,0,0,0,0,0,0,0 0,13,0,0,0,3,7,0,0,0 0,0,0,0,0,0,11,0,0,0 0,0,9,0,0,0,13,0,0,0 0,0,0,0,0,0,0,0,0,0 0,5,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,3,0,0 0,0,0,0,0,0,0,11,0,0 0,0,0,0,5,0,0,1,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,7,0,0,0,0,0,0 0,0,0,0,0,0,0,3,0,0 0,0,0,5,9,1,0,0,0,0 0,9,0,0,0,0,0,0,7,11"},
{10, "0,0,11,0,0,0,0,0,0,0 0,0,0,0,11,0,0,0,0,0 0,0,0,0,0,0,0,3,0,0 0,0,0,5,9,0,0,0,0,0 0,0,0,0,3,0,0,0,0,0 0,1,0,0,0,7,13,0,0,9 0,0,0,0,0,0,0,0,0,0 5,0,0,0,0,0,0,0,0,0 7,0,0,0,0,0,0,1,0,0 13,0,0,0,0,0,0,0,0,0"},
{10, "7,0,0,0,0,0,0,0,0,0 0,0,11,0,1,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,3,0,9,0,0,3,0,0,0 0,0,0,0,0,7,5,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,9,1,0,0,0,0,11,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,5,0,0,0,0,0"}},
------------------------------------12 by 12----------------------------------
{50, {12, "0,0,0,0,0,0,0,11,0,0,0,0 0,1,0,0,0,0,0,0,0,7,0,0 0,0,0,3,0,0,0,0,0,0,0,0 0,0,0,0,13,0,0,0,9,0,0,0 0,0,0,0,9,0,0,3,5,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 5,0,0,0,0,0,0,0,0,0,15,0 0,13,0,0,0,0,11,1,0,0,0,0 0,7,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,15,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,7,0,0,0,0,0,0,9,0,0,0 0,1,0,0,11,15,9,0,0,15,0,0 0,0,0,0,5,13,0,0,0,0,0,0 0,0,0,0,7,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,5,0,0,0,0,0,0,17,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 1,13,19,0,0,0,0,0,0,0,0,0 17,3,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,3,19,11,0,0"},
{12, "0,0,0,0,17,0,0,0,0,0,0,0 0,7,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,3,11,0,0 0,0,0,0,0,0,0,0,13,0,0,0 0,0,0,0,0,0,9,0,0,0,0,0 0,0,13,0,0,0,0,0,0,0,0,0 0,0,17,0,0,0,0,11,0,0,0,0 0,0,15,0,0,0,0,0,0,0,7,0 0,0,0,0,0,0,0,0,0,1,0,5 0,0,0,5,0,0,0,9,0,15,0,0 0,0,1,0,0,0,0,0,0,0,0,0 3,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,5 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,1,0,0 0,0,0,0,0,0,0,0,0,3,0,0 0,0,0,0,0,0,3,15,9,7,0,0 0,0,0,0,0,0,13,11,0,5,0,0 0,0,0,0,0,0,1,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,11,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,15,0,0,0,0,0,13,0,0 0,0,0,0,0,0,0,0,0,0,0,0 7,0,0,0,0,0,9,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,1,0,0 0,0,0,0,0,0,0,3,0,0,0,0 0,0,0,0,0,0,0,0,0,11,5,7 0,0,0,0,0,0,7,0,0,0,0,9 0,0,0,0,3,0,0,0,0,0,0,0 0,0,0,0,0,11,0,0,0,9,5,0 0,0,0,0,0,0,0,0,0,1,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,9,0,0,0,0,0,0 0,0,0,1,0,0,0,0,7,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,5,7,0,0,0,17,0,0 0,0,5,0,0,0,0,0,0,0,0,0 0,0,0,0,13,0,0,0,0,11,0,0 0,0,0,0,15,0,9,0,0,0,0,0 0,0,0,0,1,0,15,0,0,0,0,0 0,3,0,0,0,0,0,0,0,13,0,0 0,11,0,0,0,0,0,0,17,0,0,3"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,1,0 0,0,0,0,0,0,0,0,0,3,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,9,0,0,7,11,5,0,0,0,0 0,0,0,0,0,0,9,0,13,0,0,0 0,1,0,11,0,0,0,0,0,0,0,0 0,3,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,7,5,0 0,13,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,9,0,0,0 0,0,0,0,0,0,0,0,0,13,0,0 0,0,0,0,0,5,0,0,0,1,0,0 0,0,0,0,0,3,0,0,0,0,0,0 0,0,0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,1,0,0,0,0,0 0,0,0,13,0,0,9,0,0,0,0,0 0,0,0,0,0,0,3,0,0,0,11,0 0,0,0,0,5,11,7,0,0,0,0,0"},
{12, "3,0,0,0,0,0,0,0,0,0,0,0 7,0,0,0,0,0,0,0,0,0,0,0 0,5,0,0,0,0,15,0,0,0,0,0 0,9,0,3,0,11,13,0,0,0,0,0 0,0,0,0,0,9,5,1,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 7,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,11,15,0,0,0,0,0,0,0 0,1,13,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "3,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,5,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,13,0,9,0,0,0,0 0,1,7,0,0,0,0,0,0,0,0,0 0,11,0,0,0,0,3,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,11,0,0,0,0 0,0,0,1,7,13,0,5,0,0,0,0 0,9,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,9,0 0,0,7,0,0,0,0,0,0,0,13,0 0,0,0,0,5,1,9,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,7,0,0,15,0 0,0,11,0,0,0,3,11,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 5,13,0,0,0,1,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,3,0,0,15,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,5,0,0,0,0,0,0,0,0,0 0,0,3,0,0,0,0,0,0,0,0,0 0,0,0,7,13,3,0,0,0,0,0,0 0,11,0,0,7,1,0,0,0,0,0,0 0,0,0,0,0,0,0,9,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,5,0,0,0,0,0,0,0,0 1,11,0,0,0,0,0,13,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,5,0,7,11,0,13,0,0,0,0,0 0,3,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 9,0,0,0,0,0,1,0,0,0,0,0 0,0,0,0,15,0,0,0,0,0,0,0 0,0,1,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,9,3,0,11,0,13,0,0,0 5,0,0,0,0,0,15,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,11 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,9,0,0 0,0,0,0,1,5,0,7,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,7,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,3,0 0,0,9,0,0,0,0,0,0,0,0,0 0,0,13,0,3,0,0,0,0,0,0,0 13,0,0,0,0,0,0,0,0,0,1,0 0,0,0,0,0,0,0,11,5,0,0,0"},
{12, "1,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,5,0 0,0,0,1,0,0,0,0,9,7,0,0 0,0,7,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,13,0,0 0,0,0,0,5,0,0,0,15,9,0,0 0,0,0,0,0,0,0,0,0,11,0,0 0,0,0,0,0,0,0,0,15,0,0,0 0,0,0,0,11,0,0,3,0,0,13,0 0,0,0,0,0,0,0,0,0,0,0,0 3,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,3,0,0,0,0,0,0,0,13,0 0,0,0,0,0,0,5,0,0,0,0,0 0,0,0,0,0,0,0,7,0,0,0,5 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,9,0,0,0,0,13,0,0 0,0,11,0,0,0,0,0,11,0,0,0 0,0,0,0,0,0,0,3,0,0,0,0 0,0,0,0,0,0,0,0,0,0,7,1 0,0,0,0,1,0,0,0,9,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,7,0,11,0,0,1,0,0,0,9,5 0,0,0,0,0,3,0,0,0,0,5,3 0,0,0,0,15,0,0,0,0,0,0,0 0,0,0,0,13,0,0,9,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,0,15,13,1,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,11,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,13 0,0,0,3,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,9,0,0 0,0,0,0,0,0,0,3,1,5,0,0 0,0,0,7,0,0,0,0,0,0,0,0 0,0,0,11,0,0,0,0,0,0,0,0 0,0,0,9,0,0,0,5,0,0,7,0 0,0,0,0,0,0,0,0,0,0,0,0 1,0,0,0,0,0,0,0,0,13,0,0 0,0,0,0,0,0,0,0,0,0,0,0 11,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,5,0 0,0,7,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,13,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,11,0,1,9,0,0 0,0,0,0,0,0,0,0,0,0,11,0 0,5,0,0,0,0,0,0,0,3,0,0 9,0,0,0,0,0,0,0,3,0,0,15 7,0,15,0,0,0,1,0,0,0,0,0 13,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,7,0,0,1 0,0,0,0,0,0,0,0,5,0,17,0 11,0,0,0,13,9,11,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,1,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,3,0,0,15,0,0 0,0,0,15,5,0,0,0,0,0,0,0 0,0,0,17,0,0,0,0,0,0,3,0 0,0,0,0,7,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,13 0,0,0,0,0,0,0,0,0,0,0,9"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,1,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,3,0,0,5,0,0,0 0,0,0,0,11,9,13,11,0,0,0,0 0,0,0,0,0,0,0,0,5,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,3,0,7,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,9 0,0,0,0,0,0,0,0,0,0,1,7 0,0,0,0,0,0,0,0,13,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,5,0,0,0,0,0,0,0 0,0,0,0,0,0,0,7,15,9,0,0 0,0,0,0,0,0,0,0,0,0,0,0 11,0,0,0,0,0,0,0,0,0,0,0 5,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,0,0,0,0,0 0,0,0,0,15,0,0,0,0,9,0,3 0,0,0,0,0,0,0,0,0,13,0,0 1,0,0,0,0,0,0,0,0,3,0,0 13,7,0,0,11,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 17,0,0,0,0,0,1,0,0,5,13,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,7,0,0,0,0,0,0,0,0 0,0,11,0,0,0,0,0,0,0,0,0 0,0,0,0,0,9,0,0,0,0,0,0 0,0,0,0,15,0,0,0,0,0,0,0 1,0,0,0,0,0,7,0,0,0,0,0 0,0,0,0,11,15,3,0,0,0,0,0 0,9,0,0,0,0,5,0,0,0,0,0 0,13,0,0,0,0,0,0,0,0,0,0 0,17,3,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,3 0,3,1,9,0,7,0,0,0,0,0,0 0,0,0,5,0,13,0,0,0,0,0,0 0,0,0,0,0,0,0,1,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,9,0,0,0,0 0,0,0,0,0,0,0,11,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,11 0,0,13,0,0,0,0,5,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "9,0,0,0,0,0,0,0,0,0,0,0 0,0,0,13,0,0,0,0,0,0,0,0 0,0,0,3,9,0,5,7,0,0,0,0 0,0,0,0,0,0,0,0,11,0,0,0 0,0,0,1,0,0,0,1,0,0,0,0 0,0,0,0,0,13,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,3,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,11,7,5,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,13,0,0,0,0,3,0,0,0 0,0,0,0,0,0,7,0,0,0,0,0 0,5,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,11,0,0,0,0,0,0 0,1,0,0,0,0,5,1,0,0,0,0 0,0,0,9,0,0,0,0,0,0,0,0 0,0,11,0,0,0,0,0,0,0,0,0 0,13,3,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,0,0,9,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,11,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,9,0,0,0,0,0,0,5,0,0 0,3,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,13,0,0,0,0,0 0,0,0,0,0,0,0,15,0,0,0,0 0,0,0,15,0,0,0,1,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,13,0,7,0,0,0,0,0,0,0 0,7,1,0,0,0,0,0,0,0,0,0 0,0,9,3,0,11,0,0,0,0,0,5"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,1,0,0 0,0,0,0,0,0,0,0,11,0,0,0 0,0,0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,3,0,0,0,0,5,0 0,0,0,0,0,0,0,0,9,0,0,0 0,0,0,0,0,0,0,0,0,0,1,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,11,0,0,0,0,0,0,9 0,0,0,0,0,0,0,0,0,0,7,5 0,0,0,0,0,3,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,13,0,0,0,0,0,5,0 0,0,0,17,5,0,0,0,0,0,0,0 0,0,0,0,0,0,0,3,0,0,0,0 0,0,0,0,11,0,0,17,0,0,0,0 0,0,0,0,0,0,0,1,0,7,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,13,0,0,9,0,15,0,0,0,0,0 0,0,0,0,0,0,0,0,11,0,0,0 0,0,0,0,0,0,0,9,0,0,0,0 0,15,0,0,0,0,0,0,0,1,0,0 0,7,3,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,9 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,9,11,13,0,0,0,0 1,0,0,0,0,0,0,0,0,5,0,0 0,0,0,0,0,0,0,0,0,0,0,0 5,0,0,0,3,0,0,0,0,0,0,0 0,0,0,0,7,0,0,0,0,0,0,0 0,13,0,1,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,7,3,11"},
{12, "0,0,0,0,0,0,3,0,0,0,0,0 0,0,0,0,3,0,0,9,0,0,0,0 0,0,0,0,15,13,0,0,0,5,0,0 0,0,0,0,1,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,13,11,9,5,7,0,0,0 0,0,0,0,7,0,0,0,0,0,0,0 0,0,15,0,0,1,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,11"},
{12, "13,0,0,0,0,0,0,0,0,0,0,0 1,0,0,0,0,0,0,0,0,0,0,0 3,0,5,0,0,0,0,0,0,0,0,0 7,0,0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,0,0,0,0,11,0 0,0,0,0,0,0,0,0,0,13,9,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,11,0,0,0,0,0,0,0 0,0,0,0,1,0,0,0,0,0,0,3 0,0,0,0,5,0,0,0,0,9,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,13,0,0,0 0,0,0,0,1,0,0,0,7,3,5,0 0,0,0,0,0,0,0,0,0,11,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,5,0,0,0,0,0 0,0,0,0,0,0,9,0,0,0,0,0 0,0,0,13,0,0,0,0,3,0,0,0 0,0,0,11,0,0,0,0,0,0,0,0 0,0,0,0,0,1,0,0,0,0,7,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 13,0,0,0,0,3,0,0,5,1,0,0 0,0,0,7,0,0,0,0,0,0,0,0 0,0,0,1,0,0,0,7,9,0,0,0 0,0,0,0,0,0,0,13,0,0,0,0 0,0,0,9,0,0,0,3,0,0,0,0 0,0,0,0,0,0,11,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,5,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,11 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,1 0,11,0,0,0,7,0,0,3,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,5,15,0,0,11,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,0,9,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,5,0,0,0,0 0,0,0,0,0,0,0,13,0,0,0,0 0,0,0,0,0,0,7,0,0,0,0,0 0,0,0,0,0,0,0,15,0,0,9,0 0,0,0,0,0,13,0,0,0,3,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,1,0 0,0,0,0,3,7,0,0,0,0,0,0 0,0,0,0,0,0,0,9,0,0,0,0 0,0,0,0,0,0,13,0,11,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,3,5,0,0,0,0 0,0,0,0,0,0,0,0,0,15,0,15 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,9,0,0,13,11,7,0,0,1,0 5,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,11,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,9 0,0,0,0,0,0,13,7,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,5,0,0,0,5,0 0,0,0,0,9,0,0,0,0,0,1,0 0,0,0,0,0,0,0,3,7,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,13,0,0,0,11,0,0,0,0 1,0,0,0,0,0,0,0,0,3,0,0"},
{12, "0,0,0,0,0,0,0,0,9,0,0,0 0,0,0,0,0,0,0,0,0,3,1,0 0,0,13,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,5,0,0,0,0,0 0,0,0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,11,0,0,0,0,0,0 0,0,0,0,0,13,0,11,0,0,0,0 0,0,0,0,0,0,0,9,0,0,0,7 0,0,0,0,0,0,0,0,0,0,0,0 1,0,0,0,0,0,0,0,0,0,3,5"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,5,0 0,0,13,0,0,0,0,0,0,0,0,0 9,0,3,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,3,0,0 0,0,0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,7,0 0,0,0,9,1,11,0,0,0,11,0,0 0,0,0,0,0,13,0,0,0,0,0,0 5,0,0,0,0,0,0,1,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,5,0,0,0,0,15,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,7,9,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,11,1,0,3,13,5,0,9,0,0 0,0,0,0,0,0,15,0,0,0,0,1 0,0,3,0,0,0,7,0,0,0,0,13 0,0,0,0,0,0,0,0,0,0,0,11 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,9,0,0,0,0,0,0,0,7,5,0 0,11,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,17,3,0,0 0,0,0,0,0,0,0,0,15,0,0,0 0,0,0,0,3,0,0,0,0,0,0,0 0,0,0,0,1,0,0,13,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,11,0,0,0,7,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,5,0,0,0,9,15,13,0,17,0 1,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,5,0,0,0,0,0 0,1,11,0,0,0,0,0,0,0,0,0 13,0,9,1,0,0,0,7,5,0,0,0 0,0,0,0,3,0,0,13,3,0,0,0 0,0,0,0,0,0,0,11,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,7,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,3,0,0,0,0,13,0,0,0,0 0,0,0,0,0,0,0,3,0,0,0,0 0,0,0,0,0,9,11,5,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,7,13,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,7,0,0,0,0,0,0 1,0,0,0,5,11,0,9,0,0,0,0"},
{12, "0,0,0,5,13,0,0,0,0,0,0,0 0,0,0,0,0,9,0,0,0,0,5,3 0,0,0,0,0,0,0,3,0,7,1,0 0,0,0,0,0,0,0,0,0,0,11,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,11,0,0 0,9,0,0,0,0,0,13,0,0,7,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,1,0,0,0,0,0,0,0,13,3 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,5,9,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,7,0,0,0,0 0,0,0,5,3,9,1,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,7,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,11,0,0 0,0,11,0,0,13,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 13,0,0,0,0,0,9,0,0,0,0,0 0,0,7,0,5,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,5,0,11,0,15,0,0 0,0,0,0,0,0,0,13,0,0,0,0 0,0,0,9,3,0,0,0,0,0,0,0 0,0,0,1,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 15,0,0,1,0,0,0,0,0,3,0,0 11,7,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,1,0,0,0,0,17 0,3,0,0,0,0,0,0,7,0,0,0 0,13,0,0,0,0,0,0,0,0,0,0 0,9,11,0,0,0,0,5,0,0,0,0 0,0,0,0,0,13,3,15,0,0,0,0 0,0,0,0,0,0,1,0,0,0,0,0 7,15,0,0,0,11,9,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,5,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,17,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,0,0,0,0,0,0,0,0,0 0,7,0,0,0,0,0,0,0,0,5,0 0,0,0,11,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,3,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 13,0,0,1,9,0,3,0,0,0,0,0 0,0,0,7,0,0,0,0,0,0,0,0 13,0,0,0,0,0,0,0,0,0,0,0 9,5,11,0,0,0,1,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0"},
{12, "0,0,0,3,0,0,0,0,0,0,0,0 0,1,0,0,7,0,0,13,0,0,0,0 0,0,0,0,0,0,17,0,0,0,0,0 11,0,0,0,0,1,0,0,3,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,11,0,0,0,0,0,0,0,0,0,0 0,0,0,0,9,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,9,7,0,0,0,0,0,0,15,0,0 0,0,0,0,0,0,0,0,5,0,0,0 13,0,0,0,0,15,0,0,0,0,0,0 5,0,0,0,0,0,0,0,0,0,0,17"},
{12, "0,0,0,5,11,0,1,0,0,0,0,0 0,9,0,0,0,0,0,0,7,0,3,0 0,0,0,0,0,0,0,0,13,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,11,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,5,0,0,0,0,0 0,0,0,0,0,0,3,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,7,0,0,0,0,0 0,0,9,0,0,1,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,13,0"}},
------------------------------------14 by 14----------------------------------
{50, {14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,1,0,0,0,1,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,0,11,0,0,0,0,0 0,9,0,0,0,0,0,0,0,0,23,0,0,0 0,0,0,15,7,0,29,0,0,0,0,0,0,0 0,0,13,0,13,0,0,15,0,0,0,0,0,0 23,0,0,0,0,0,0,29,0,0,0,17,0,0 0,0,0,0,17,0,0,5,0,21,0,0,0,0 0,0,0,0,19,0,0,19,0,25,0,0,0,0 0,0,3,5,0,0,0,0,0,0,0,0,0,27 0,0,0,0,3,0,0,0,0,0,21,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,25,0,11,27,0,0,0"},
{14, "11,13,17,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,5,0,0,0,0,1,0,0,19,0 0,0,0,0,0,0,0,0,0,0,0,0,1,9 0,3,0,0,0,0,0,0,0,9,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,21,19 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,15,0,0,0 0,0,0,0,0,0,0,17,0,7,11,0,0,0 0,0,0,0,0,0,0,0,0,0,21,0,0,0 0,0,0,0,0,0,5,0,0,0,13,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 7,15,3,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,13,0,0,0,0,17 0,3,0,0,0,0,3,0,0,0,0,5,0,0 0,0,0,0,0,0,0,0,9,0,0,9,0,0 0,21,11,0,0,0,0,0,0,0,0,0,0,17 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,15,0,0,5,0,0,0,0,13,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,19,0,1,0,0,0,1,0,0,27,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,15,0,0,0,0,0,0,0,0,0,0,23,0 0,0,0,0,0,0,0,0,0,19,25,0,0,0 11,0,0,0,0,7,0,0,0,0,0,21,0,0 27,25,0,0,0,0,0,23,0,0,0,0,0,0 0,0,0,7,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,29,0,0,0 0,0,0,0,0,0,7,0,0,0,0,0,21,0 15,0,1,0,1,0,0,0,0,15,0,0,0,0 17,0,0,0,9,0,25,0,0,0,0,0,0,3 0,0,0,0,0,0,0,0,0,0,0,0,0,21 0,19,0,0,23,0,0,7,0,0,0,0,0,0 0,0,0,17,0,0,0,0,0,0,0,0,3,0 0,0,0,25,0,0,23,0,0,0,0,0,0,0 0,0,0,19,0,0,0,0,0,0,0,0,0,0 0,0,0,9,0,0,13,0,0,0,0,27,0,0 0,0,0,29,0,11,0,0,0,0,0,0,0,0 0,11,13,0,0,0,0,0,0,5,0,0,0,0 0,0,0,0,0,0,0,0,27,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,5"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,27,0,0,0,0,0,0,0,0,27,0,7,0 0,0,0,0,0,0,0,0,0,0,0,0,5,0 9,0,0,0,0,0,0,0,13,11,13,23,0,0 17,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,1,0,0,0,0,0,0,0,0 0,0,0,0,0,17,0,0,0,0,3,0,0,0 0,0,0,0,0,19,0,0,0,0,15,0,0,0 0,0,0,0,0,21,0,0,0,0,0,0,5,0 0,0,0,11,0,0,0,0,1,0,0,0,3,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,7,21,0,0,0,19,0,0,25,0,25,0,0 0,0,0,0,0,0,0,0,0,23,15,0,0,9"},
{14, "0,9,0,0,0,23,15,0,0,0,0,0,0,0 0,23,0,0,0,9,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,19,0,0 31,0,0,0,0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 31,0,0,0,0,0,0,0,0,1,0,0,0,0 15,0,0,0,13,17,0,0,0,21,0,0,0,0 0,0,0,17,0,0,0,1,21,0,0,0,0,0 0,0,0,0,27,0,0,0,0,0,0,0,0,0 0,0,5,0,11,0,0,0,0,7,0,0,0,0 0,0,25,0,0,19,0,5,0,0,29,0,3,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,11,29,13,3,0,0 25,27,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "23,27,0,0,0,0,0,0,0,0,0,0,0,0 0,1,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,11,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,9,0,0,0,0,13,0,0,0 0,0,0,0,0,0,0,0,0,0,5,0,0,0 0,0,19,0,0,0,0,3,7,0,0,0,0,0 0,0,0,0,0,0,0,23,17,0,0,0,0,0 0,0,11,1,0,0,27,0,0,0,0,3,0,0 0,0,0,0,0,0,0,0,0,13,0,0,0,0 0,0,0,0,0,15,0,0,0,0,0,0,0,0 21,25,15,0,0,0,9,0,0,0,17,5,19,0 0,0,0,0,0,0,0,0,25,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,21"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,19,0 0,0,0,0,0,0,0,0,0,0,3,0,5,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,3,9,0,0,7,0,0,1,0,0,0,11,0 0,7,0,0,0,0,0,0,0,0,13,0,23,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,19,0,0,0,9,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,13,17,23,0 0,17,1,15,0,15,0,0,0,0,0,0,27,0 0,0,0,0,0,0,0,0,0,0,21,25,0,0 0,0,0,0,0,0,0,0,5,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,25,21,0,0 11,27,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,17,25,0,0,0,0,0,0,0,0,0,0,25 0,3,9,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,15,19 0,0,0,0,0,0,0,13,21,0,0,0,0,5 0,0,0,0,0,0,7,0,0,0,0,0,0,0 0,0,0,0,0,13,0,0,11,0,0,0,0,0 0,0,0,0,0,0,0,0,7,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,9,0,0,1,0,0,0,0,0,0,0 0,17,0,0,0,0,0,0,0,0,0,0,15,5 0,0,0,0,0,0,0,0,21,0,0,0,0,0 0,23,0,1,0,0,0,0,0,0,0,0,3,0 0,11,23,19,0,0,0,0,0,0,0,0,0,0"},
{14, "21,0,0,0,0,0,0,0,0,0,17,0,0,0 0,0,11,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,3,0,0,0,15,0,0,0 0,19,0,0,0,0,0,0,15,0,17,0,0,0 0,0,0,0,0,27,0,0,0,0,5,0,0,0 23,0,0,0,0,0,7,13,0,0,0,0,0,0 0,0,0,0,0,0,13,0,0,0,0,0,0,0 0,0,0,27,0,0,7,0,0,0,0,0,19,0 0,0,0,9,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,11,0,0,0,5,0,0 0,0,0,3,0,0,0,0,1,0,0,0,0,0 0,0,0,23,21,9,25,0,0,0,0,0,1,0 25,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "19,0,0,0,0,0,0,0,0,0,0,0,0,19 5,0,0,0,11,13,0,0,0,0,13,0,0,0 0,0,3,0,0,0,0,0,0,0,0,0,15,0 0,0,17,0,3,7,21,0,25,15,0,0,0,0 0,0,0,0,0,0,0,0,9,0,0,0,11,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,7,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,5,1,0,0,0,0,0,0,0,0,0,0 0,0,23,0,0,0,23,0,0,0,0,0,0,0 0,0,1,0,0,0,0,0,0,0,0,0,0,0 0,0,17,0,0,0,0,0,0,0,0,9,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 21,0,0,0,0,25,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,15,21,3,11,0,0,0,0,0,0,0 0,0,21,0,0,0,7,0,0,0,0,0,0,0 0,0,0,0,0,3,0,0,0,0,0,0,0,0 0,0,0,9,0,0,0,13,0,13,0,0,0,0 0,0,0,0,0,0,29,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,7,0,0 0,0,0,15,17,0,0,25,23,29,0,11,0,0 0,17,0,19,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,1,0,0,0,0,0,0,0,0 19,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,27,25,0,0,0 0,0,0,0,0,0,0,0,0,0,0,1,23,0 27,9,5,0,0,0,0,0,0,5,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,13,0,0,0,0,0,0 0,0,5,0,0,19,0,19,0,0,0,1,0,0 0,0,11,0,5,0,0,0,0,0,21,0,0,0 0,0,13,0,0,0,21,11,0,0,0,0,0,0 0,0,0,0,0,1,0,0,0,0,0,0,0,9 0,0,0,17,0,0,0,0,0,0,0,0,25,0 0,0,0,7,0,0,0,0,0,9,0,0,23,0 0,0,0,0,0,7,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,15,17,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,15,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,3,0,0,0,0,0,3,23,25,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,0,0,0,0,0,0,0 0,0,13,7,0,0,0,0,0,0,0,11,0,0 0,0,0,0,0,0,0,1,0,0,0,0,0,0 0,0,15,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,15,0,0,13,0,0,0,0 0,0,0,17,0,11,0,0,0,0,0,0,0,0 0,23,0,0,0,0,9,0,0,0,3,0,3,0 0,0,0,0,0,0,0,0,21,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,19 0,0,0,0,0,0,0,0,5,0,0,0,0,0 0,5,23,0,17,0,0,25,0,0,19,21,0,0 0,0,0,0,0,0,0,0,9,0,0,25,0,0 0,7,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,9,0,0,0,0,0,0,0,0,0,0,5,0 0,0,0,7,3,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,7,0,0,0,0 0,0,0,0,0,19,0,3,17,0,0,0,0,0 0,0,21,0,0,21,0,0,0,0,0,0,0,0 0,0,0,0,0,17,0,0,0,1,0,0,0,0 0,0,0,23,0,23,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,13,0,0,0,0,9,0,5,13,15,25,11 0,25,0,0,19,0,0,0,0,15,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,11"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,7,1,0,0,0,0,0,0,0,0,0,11,0 0,0,0,0,11,13,0,0,0,17,0,0,17,0 0,19,0,3,5,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,7,0,0,0,0,0,0,0 0,0,0,23,25,0,0,0,0,27,0,5,0,0 1,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,27,0,0,25,0,19,0,29,0 0,23,15,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,9,0,9,0,0,0,0,0,0,0 0,0,15,0,0,0,0,0,0,3,13,0,0,0 21,0,0,0,31,0,0,31,0,0,29,0,0,0 0,0,21,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,5,0,0,0,0,0,5 0,0,0,0,0,0,0,0,0,0,0,3,1,0 0,0,0,0,17,0,0,0,9,29,0,0,0,0 0,0,0,7,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,3,0 0,0,17,0,0,0,0,0,0,11,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,25,0,7,0,0,0,15,19,15,29,0,0,0 0,23,0,0,0,0,0,0,0,13,0,0,0,0 0,27,0,0,0,0,0,19,13,0,0,0,0,0 23,0,0,0,0,11,0,0,0,21,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,9,0,0,0,0,0,0,0,0,27,0,0,1 0,0,0,0,0,0,0,0,0,0,21,0,0,25"},
{14, "17,0,0,0,0,0,0,0,0,0,3,5,0,0 0,0,0,0,0,7,0,0,21,0,0,21,25,0 0,1,0,0,0,19,17,0,0,0,0,0,0,0 0,0,0,0,0,5,3,0,0,23,0,0,27,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,7,0,9,0,13,11,0,0,0,0,0 0,0,0,0,0,0,0,1,0,0,0,0,0,0 0,0,0,0,9,0,0,0,0,0,0,0,0,0 0,0,0,0,0,19,0,0,0,0,0,0,0,0 0,0,0,15,0,15,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,11,0,0,0,0,0 0,0,0,0,0,0,0,0,23,0,0,25,0,0 0,13,0,0,0,0,0,0,0,0,0,27,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,21,7,17,0,0,0,0,0,0,0 0,7,0,0,0,0,0,0,1,0,0,0,0,0 0,0,0,0,0,0,0,0,3,15,0,0,0,0 0,0,13,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,11,0,11,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,19,0,0,0,15,0,0 0,0,0,0,0,0,0,0,0,0,0,3,0,0 0,17,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,19,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,23,0,0 0,0,5,21,0,0,9,13,0,0,0,0,0,0 0,0,0,0,0,0,23,5,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,3,0,0,0,0,0,3 0,0,0,0,0,0,0,5,0,0,0,0,0,0 0,0,0,0,29,0,0,7,0,0,0,0,0,0 0,0,0,0,9,0,0,11,0,13,0,0,0,0 0,0,0,0,17,0,0,15,0,21,23,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,17,0,0,0,11,0,0,0,0,0 0,0,0,0,0,0,0,0,0,21,0,0,0,0 0,0,0,0,27,0,0,13,0,0,0,0,0,0 7,0,25,0,0,0,0,0,0,0,0,0,0,0 0,0,0,1,0,0,0,0,0,0,9,0,0,0 0,0,0,0,0,0,0,27,0,29,0,0,0,0 0,25,0,0,0,0,0,0,0,19,0,5,0,15 0,23,1,19,0,0,0,0,0,0,0,0,0,0"},
{14, "11,0,0,0,11,0,0,0,0,0,0,0,15,0 0,0,0,0,0,0,0,0,0,0,7,0,31,0 0,9,0,0,0,0,0,5,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,5,3,0,0 0,0,0,3,7,0,21,0,0,0,0,0,31,0 0,0,19,25,13,0,0,0,0,0,0,0,0,0 0,0,9,0,0,0,13,0,0,0,0,0,0,21 0,0,19,0,0,0,0,0,0,0,0,0,0,0 0,0,29,0,0,0,0,17,0,0,0,0,0,0 0,0,0,0,0,0,0,0,23,27,0,0,0,0 0,0,23,0,0,1,0,0,0,0,1,0,25,0 0,17,0,0,0,0,0,0,0,0,0,0,0,0 0,27,0,15,0,0,0,0,0,0,0,0,0,29 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,9,0,0,0,0,0,0,0,11,0,0,7,0 5,0,0,0,0,0,0,0,0,0,0,23,0,0 3,0,0,5,15,0,0,0,0,0,9,0,0,0 0,0,0,0,0,0,0,0,11,0,15,0,7,0 0,0,0,0,0,0,0,0,0,0,1,0,0,0 0,23,0,0,17,27,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,17,21,0,25,0,0,0 0,0,0,0,0,0,0,0,27,0,0,0,0,0 0,0,0,0,1,0,0,19,0,0,25,0,0,0 0,0,0,0,0,0,0,0,19,0,21,0,0,0 0,13,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,13,0,0,0,0,0,0,0,0,0,0 0,0,0,0,3,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,13,5,7,0,7,0,0,0,0,0,0,0,0 0,0,0,0,5,21,0,9,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,11,0,0,0 0,0,0,1,0,15,0,0,19,0,0,0,0,0 0,0,0,15,1,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 25,0,0,0,0,0,0,0,0,0,0,17,0,0 0,0,19,3,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,23,0,0,0,17,0,0,0 0,0,0,3,0,0,9,0,0,0,0,23,0,0 0,13,0,0,11,0,0,0,0,21,0,0,0,0 0,0,25,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,3,0,0 0,0,23,7,0,0,0,0,0,0,0,0,0,0 0,0,0,0,9,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,0,0,0,0,0,0,0 13,0,0,0,0,0,7,0,1,0,0,0,0,0 0,0,0,0,17,15,0,0,0,0,0,0,0,0 19,13,0,15,0,21,5,0,0,0,0,0,0,0 0,0,23,0,0,0,0,21,0,0,27,0,0,0 0,0,0,0,0,0,0,5,0,9,0,0,0,0 0,17,25,0,0,19,0,0,25,27,0,0,0,0 0,11,0,0,11,0,0,0,0,0,0,0,0,0 0,3,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,25,5,0,0,0,0,0,0,0,11,0,0 0,0,0,0,0,0,0,0,7,9,0,0,0,0 0,0,0,0,0,0,13,0,0,0,0,0,0,0 0,0,0,0,15,0,3,0,0,7,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,13,0,0,0,0,0,3,0,0,0 0,0,0,0,15,0,0,0,0,0,0,0,0,0 0,21,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,17,0,0,0,0,0,0,0,0 0,0,0,0,0,5,0,0,0,0,0,17,0,0 0,0,0,0,1,0,0,0,19,0,0,23,0,0 0,21,25,0,0,0,0,0,11,0,0,19,0,0 0,0,0,27,9,1,0,0,0,0,0,23,27,0"},
{14, "23,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,5,7,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,17,0,0 0,0,0,17,3,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,11,0,0,0,0,0,0 0,0,0,0,0,3,0,0,0,0,0,0,0,0 23,0,0,0,0,11,9,0,0,0,0,0,0,0 0,0,1,0,0,0,15,13,0,0,0,0,0,0 0,0,0,21,1,15,19,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,5,0,0,0,0 0,0,0,0,0,0,0,0,0,13,0,0,0,0 0,0,0,0,9,0,0,0,0,0,0,0,0,0 0,21,19,0,0,0,0,0,0,0,0,0,7,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,5,0,0,0,0,0,0,0,0,0,0 0,9,0,0,11,17,27,0,0,0,0,0,21,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,9,19,0,0,0,0,0,0,17,15,1,0,0 0,0,0,0,0,0,25,0,0,0,0,23,21,11 0,0,0,23,0,0,0,0,0,0,0,3,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,25,0,15,0,13,0,0,0 0,0,0,0,0,7,0,0,0,0,0,0,0,0 0,0,0,0,0,27,0,7,0,0,0,13,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,1,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,19,5,0,0,0,0,0,0,3"},
{14, "0,0,0,0,0,0,0,0,0,3,0,0,3,1 0,11,0,0,0,0,0,17,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,15,0,0,0 0,0,0,0,1,0,0,0,0,0,0,0,0,0 0,0,0,13,0,0,0,25,0,0,0,5,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,17,0,9,0,0,0,0,0 13,0,0,25,7,0,0,0,0,0,0,21,0,0 0,0,0,0,0,0,0,0,0,9,0,19,0,0 0,5,0,0,0,0,0,0,0,0,0,0,0,0 0,0,7,0,0,0,0,0,0,0,21,0,0,0 0,0,0,0,19,0,0,0,0,23,0,23,0,0 0,15,0,0,0,0,0,0,0,0,0,0,0,11 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,29,0,1,7,0,0,0,0,0 0,0,0,0,5,0,0,0,0,0,0,0,11,0 0,0,0,0,0,0,19,0,0,0,0,0,7,0 29,0,1,0,0,17,0,0,0,25,0,0,3,0 21,0,17,0,0,23,0,0,0,0,0,0,0,0 0,0,0,0,0,19,0,0,0,0,0,0,0,0 0,0,21,0,0,0,0,23,0,0,13,0,0,0 0,0,0,0,11,0,0,0,0,5,9,0,0,0 0,9,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,3,27,15,0,0,0,0 0,0,15,27,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,25,0,0 0,0,0,0,0,0,0,0,0,0,0,13,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,25,0,0,25 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,29,11,3,9,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,15,21,0,0 0,0,0,0,0,0,3,9,0,0,7,0,0,0 0,0,0,0,0,0,15,0,0,0,13,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,7,19,0,0,0,0,0,0,0,21,0,0 0,0,0,0,0,0,0,0,5,0,5,23,0,0 0,11,0,0,0,0,0,0,0,27,0,0,0,0 0,1,0,0,0,1,0,19,0,0,27,0,0,0 0,0,0,0,0,0,0,0,0,13,23,0,0,0 0,0,17,0,0,0,0,17,0,0,0,0,0,0 29,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,3,0,0,0,0,0,0,0,0,0,0 0,29,9,0,0,13,0,0,0,0,13,11,0,0 0,0,0,0,0,0,0,0,0,0,0,29,0,0 0,0,3,11,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,15,19,0,0,0 0,0,0,0,0,0,17,15,21,0,21,23,0,0 0,25,0,0,0,0,0,25,23,0,0,0,0,0 0,19,0,27,0,0,0,0,0,0,0,0,0,0 0,0,17,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,7,0,0 0,1,0,0,0,27,0,0,0,0,0,0,0,0 0,0,5,1,0,0,0,7,5,9,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,25,13,5,0,0,0,7,0,0,0,0,0 0,0,11,0,0,0,13,0,15,0,0,0,7,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,17,15,0 0,0,0,0,19,0,0,0,0,0,0,0,0,0 0,0,0,0,9,0,0,23,0,0,0,0,0,27 0,0,0,0,0,0,1,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,5,0 0,0,0,0,9,21,0,0,0,0,0,0,11,0 0,0,0,0,0,0,0,0,3,0,0,0,0,0 17,0,0,0,3,29,0,0,31,0,0,21,0,0 0,0,1,19,0,0,0,0,0,0,0,0,0,0 25,29,0,0,0,31,0,23,27,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,5,7,9 0,0,0,0,0,17,0,5,0,0,0,0,0,0 0,0,27,0,0,0,0,7,0,0,0,0,1,0 0,0,0,0,0,0,0,0,0,0,0,0,27,0 0,0,0,0,0,0,0,0,0,13,0,9,0,0 0,0,1,0,31,19,0,0,0,0,0,0,0,0 0,17,0,0,0,0,0,11,0,0,0,0,25,0 0,0,0,0,0,0,0,21,0,25,0,0,0,0 0,13,31,0,0,0,0,0,0,23,0,29,0,0 0,0,0,0,19,0,0,0,0,0,0,0,0,0 0,0,3,0,29,0,21,0,0,0,0,0,0,0 0,0,0,0,23,0,0,0,0,0,0,11,0,0 0,15,3,0,0,0,15,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "25,0,0,0,0,0,0,0,0,0,0,0,0,0 21,0,7,0,0,0,0,0,0,0,0,0,0,0 0,0,29,0,13,23,0,13,0,0,0,29,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,15,17,0,0,0,0,0,11,0,0,0,5,0 0,0,0,0,0,27,0,23,0,0,5,0,19,0 0,0,0,0,0,0,0,0,0,0,0,19,0,0 0,0,17,0,0,0,0,0,0,27,0,0,0,1 0,0,0,0,0,7,0,0,0,0,0,0,0,0 0,0,3,0,0,0,0,0,0,11,0,0,0,0 0,0,15,0,0,0,0,0,0,0,0,0,0,0 0,0,25,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,9,0,0,0,0,0,0,0,0,0 0,0,21,3,0,0,9,1,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,7 0,0,0,0,0,0,0,0,0,0,0,0,0,9 0,0,0,0,0,0,0,0,0,0,0,0,0,13 0,0,0,15,0,0,0,0,0,0,1,11,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,17,23,0,0,0,0,0,0 0,0,0,0,0,19,21,0,0,0,0,0,0,3 0,0,0,0,0,0,0,11,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,3 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,19,0,0,0,0,15,0,0,0 0,0,1,5,17,21,0,0,0,0,0,5,0,0 0,0,0,0,0,0,0,0,23,0,0,7,0,0 0,0,0,0,0,0,0,0,0,0,9,0,0,13"},
{14, "5,0,0,0,0,0,0,0,0,0,0,0,0,7 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,23,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,7 0,1,0,0,0,0,0,3,5,1,0,23,0,0 0,0,0,0,0,0,0,0,0,0,0,13,11,0 9,17,0,3,0,0,0,0,19,0,0,17,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 15,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,15,9,0,0,0 0,11,21,0,0,0,21,0,0,0,0,0,0,0 0,19,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,13,0,0,0,0"},
{14, "25,0,0,0,0,0,0,0,0,0,0,5,0,0 0,0,0,0,0,0,0,0,0,0,25,1,0,0 0,0,0,0,0,0,0,0,0,11,9,29,0,0 0,0,3,0,0,0,0,0,0,0,0,0,0,0 0,0,21,0,0,0,29,0,0,0,15,0,0,5 0,0,0,0,0,0,0,19,0,0,19,0,0,0 0,0,0,21,0,0,0,0,0,0,0,0,7,0 17,0,0,0,0,0,0,0,0,0,0,15,0,0 0,0,0,0,0,0,0,0,11,0,13,23,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,9,3,0,0,17,1,23,0,0,0,0,0 0,0,0,0,0,0,0,0,7,0,0,0,27,0 0,13,0,0,0,0,0,0,27,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,7,0,0,0,0,1,0,0,0,0 0,11,0,0,0,0,15,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,13,0,0,0,0,0 0,0,17,0,11,25,0,0,0,15,21,0,0,0 0,0,0,0,0,0,0,3,0,3,0,13,0,0 0,0,0,0,0,23,0,0,0,0,0,0,0,0 0,0,23,0,0,19,0,0,1,0,0,0,0,0 0,0,0,17,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,19,0,0,0,0,27,9,25,0 0,0,21,0,0,0,0,0,0,9,0,0,0,0 0,0,0,0,0,0,0,0,0,0,27,0,7,5 0,0,0,0,0,0,0,0,0,0,0,0,0,0 29,0,0,0,0,0,0,29,0,0,0,0,0,0 5,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,5,0,0,0,0,0,0,0 0,0,1,0,0,0,0,0,0,0,13,21,0,0 0,0,0,0,25,0,0,0,0,0,27,0,0,0 0,0,0,0,0,0,19,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,11,0,0,5,0,0 0,0,15,0,0,19,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,17,3,0,0,0,0,0,0 25,27,0,0,0,0,0,0,0,3,23,0,0,13 7,17,0,0,0,0,0,0,0,21,0,0,0,9 0,0,15,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,1,11,0,0,0,0,0,23,0 0,7,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,5,0,0,0,0,0,0,0,0,0,5 0,7,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,11,0,0,0,19,0,13,0,0,1,0 0,0,0,0,0,13,0,0,0,0,0,0,0,0 0,0,0,0,0,21,0,0,0,0,0,0,0,0 0,0,0,9,0,17,0,17,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,11,21,0,27,0 0,0,0,0,0,0,31,0,3,0,31,0,0,0 0,7,25,0,0,0,0,0,0,0,0,0,0,0 0,9,0,0,0,0,0,0,0,0,0,0,0,0 0,29,0,0,0,0,0,0,0,0,0,0,0,0 0,0,15,23,15,23,0,0,0,3,0,0,27,0 0,0,29,0,0,0,0,0,0,0,0,0,1,0 0,19,25,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,13,3,27,0,0,0,27,11,0,0,15,19,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,13,0,0,0,0,0,5,0 0,0,0,0,0,0,17,0,1,15,0,0,0,0 0,0,0,0,0,0,0,0,23,19,0,9,0,0 0,0,0,23,0,0,0,0,0,9,0,0,0,0 0,17,0,0,0,0,0,0,0,0,0,21,0,0 0,31,0,25,0,0,0,0,3,0,0,5,0,0 0,0,0,0,0,0,29,0,0,0,0,0,21,0 7,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,25,0,0,0,0,0,0,0,0,0,1 0,0,0,0,0,0,0,0,0,0,11,0,0,29 7,0,0,0,0,0,0,0,0,0,0,0,0,31"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 25,0,0,0,0,0,0,0,0,5,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 17,11,0,0,0,0,21,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,15,0,17,0,0 0,0,0,0,0,3,0,0,0,0,0,0,0,0 0,0,1,0,0,0,0,0,0,0,29,0,5,0 0,0,0,0,0,19,1,0,0,0,0,0,25,0 0,0,7,0,23,0,23,3,0,0,0,0,0,0 27,0,0,0,0,0,0,0,0,0,0,13,0,0 0,0,0,7,19,0,21,11,29,0,0,0,0,0 9,0,0,0,0,0,9,0,0,0,15,0,0,0 0,0,0,0,0,27,0,0,0,0,0,0,13,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,25,0,0,0,0,3,7,0,0,0,0,0,0 0,0,0,11,0,0,0,0,0,17,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,29,0,0 0,0,0,0,0,0,5,1,0,0,0,23,0,0 0,0,0,0,0,0,0,19,0,0,0,27,0,0 0,3,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,19,0,27,0,0,0,0,0 0,0,7,0,0,0,21,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,15,0,0,0,0,0 0,11,0,9,0,0,0,29,0,0,25,0,0,0 0,0,0,0,0,21,0,13,0,0,0,0,0,0 0,0,9,0,0,0,0,0,15,0,0,0,0,0 0,0,0,0,1,5,13,23,0,0,0,0,17,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,5,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,1,3,0,0,0,0,0,0,0,7,0,0 0,0,0,0,0,0,0,13,1,3,0,0,0,0 0,0,13,0,0,0,0,0,0,11,0,0,0,0 0,0,7,0,0,0,0,17,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,15,9,0,0,0,0,0,0,0,0,0,0 0,0,21,0,0,17,0,0,0,0,0,0,0,0 0,0,0,9,15,23,0,0,0,0,11,0,0,0 0,0,0,0,0,0,21,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 5,19,0,0,0,0,0,0,0,0,0,0,19,0 23,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,1,0,9,0,0,7,0,0,0,0,0,5,0 0,31,0,11,0,0,0,0,15,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,21,0,0,7 0,0,0,1,0,0,9,5,0,0,0,0,0,0 0,0,11,0,0,0,0,0,0,0,0,0,0,0 0,31,0,0,0,0,0,0,0,0,0,17,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 19,0,0,0,0,0,0,0,0,0,27,0,0,0 3,13,25,0,0,13,0,0,0,19,0,17,0,0 0,0,0,0,0,0,25,21,0,27,0,0,0,0 0,0,0,0,0,23,0,23,15,0,0,0,0,0 29,0,0,29,0,0,0,0,0,0,0,0,0,3"},
{14, "0,0,0,0,0,0,0,0,11,0,1,0,29,7 0,0,0,0,0,0,0,0,0,0,29,0,21,0 0,0,0,0,0,0,0,0,0,15,5,9,0,0 0,0,0,0,0,0,0,15,0,0,0,0,0,0 0,0,0,0,13,0,0,0,0,0,0,0,0,7 0,0,0,0,0,0,0,0,9,0,19,0,0,0 0,0,0,0,0,0,0,0,0,0,5,0,0,21 0,0,25,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,3,0,0,0 0,23,0,0,13,27,0,0,0,0,0,0,25,0 0,17,0,0,0,0,0,0,0,0,0,0,19,0 0,0,0,0,0,0,17,23,27,11,0,0,0,0 3,0,0,0,0,0,0,0,0,0,0,0,1,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,3,0,15,11,0,0 0,0,0,0,0,0,0,0,0,0,7,9,0,0 0,0,19,0,0,0,0,0,0,9,0,0,0,0 0,0,0,0,0,0,0,0,13,0,13,0,0,0 0,0,3,0,0,0,15,0,23,0,0,0,0,0 17,0,0,0,0,0,1,0,0,0,0,0,0,0 5,0,0,0,0,0,0,0,11,0,0,0,0,0 1,0,0,0,0,0,0,0,0,0,23,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,17,0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,21 0,19,0,0,0,0,5,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,21,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,7,0,0,0,0,0,21 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,11,0,0,0 0,0,1,17,0,0,0,21,3,0,0,0,0,3 0,0,0,0,0,0,0,13,0,0,25,0,0,0 0,0,15,0,0,0,0,0,0,0,0,0,0,0 0,0,9,0,0,0,1,0,0,0,0,0,13,11 0,0,0,0,0,0,0,0,25,0,9,0,0,19 0,0,0,0,0,0,0,0,0,0,0,5,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,5,0,0,0,0,0,0,0,23,0 0,19,17,0,0,0,15,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,23,0,0,0,0,0 7,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,27,5,0,0,0,0,0,0,0,0,0,25 0,0,0,0,0,9,0,0,0,0,0,9,0,0 0,0,15,0,0,0,0,0,0,0,0,19,0,0 0,0,0,0,0,0,0,0,23,15,0,0,0,0 0,0,0,0,0,11,0,0,0,0,31,3,0,0 0,5,0,0,0,0,0,0,29,0,0,0,0,0 0,27,0,0,0,1,29,1,0,0,17,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,17,11,0,0,0,0,0,0,0,0,0,0,0 0,0,23,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0,0,0,3,0 0,0,19,0,0,21,31,0,0,0,0,0,0,0 7,21,0,0,25,0,0,0,13,0,0,0,13,7 0,0,0,0,0,0,0,0,0,0,0,0,0,0"},
{14, "0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,1,0,0,0,0,0,23,15,0,0,0,15,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,11,17,0,0,0,0,21,0,0,0,0,0 0,0,0,0,0,0,13,0,0,0,0,0,5,0 0,0,0,0,0,0,3,1,0,0,23,0,0,25 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,27,0,21,0,0,19,7,0 0,0,0,0,3,19,0,0,0,0,25,0,0,0 0,0,0,0,0,0,0,0,27,17,11,0,0,5 0,0,0,0,0,0,0,0,0,0,0,0,0,0 0,0,0,13,0,0,0,0,0,0,0,0,9,0 0,0,0,0,0,0,0,0,0,0,0,0,0,0 9,0,0,0,0,0,0,0,0,0,0,0,0,7"}},
------------------------------------variety----------------------------------
{50, {9, "0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,1,5,0 0,0,0,0,0,0,3,0,0 0,0,0,7,0,3,5,0,0 0,0,0,0,0,0,0,11,17 0,0,0,0,9,0,0,0,13 0,0,0,7,15,0,0,9,0 0,1,11,13,0,0,0,15,0 0,0,0,0,17,0,0,0,0"},
{6, "0,0,0,5,1,9 0,1,0,0,0,0 0,7,0,0,0,0 0,0,5,7,0,3 9,0,0,0,0,0 3,0,0,0,0,0"},
{5, "0,0,5,0,1 0,0,0,0,7 0,0,7,0,0 0,1,3,0,3 0,0,0,0,5"},
{6, "0,0,0,0,0,0 0,5,0,0,5,0 0,0,1,0,9,0 7,0,9,0,0,0 3,0,0,1,0,7 0,3,0,0,0,0"},
{7, "9,1,0,1,0,0,0 0,0,0,9,0,3,0 0,0,0,7,11,0,0 0,0,0,0,0,0,0 0,0,3,0,5,0,0 7,0,11,0,0,0,0 5,0,0,0,0,0,0"},
{8, "13,0,0,0,0,0,0,0 0,1,0,0,0,0,0,0 13,11,0,9,0,9,0,0 1,3,0,0,0,0,0,0 0,0,0,5,0,11,0,0 0,0,0,0,0,0,0,5 0,3,0,0,7,0,7,0 0,0,0,0,0,0,0,0"},
{8, "0,0,0,0,9,0,0,0 7,11,3,0,0,5,1,0 0,0,0,3,7,0,0,0 0,5,0,0,0,0,0,0 0,1,0,13,0,0,0,0 0,0,0,0,0,13,0,0 9,0,0,11,0,0,0,0 0,0,0,0,0,0,0,0"},
{7, "0,0,0,0,0,0,0 0,3,0,0,0,0,0 0,0,0,5,0,0,0 0,0,0,1,5,9,7 0,0,0,0,0,0,1 0,3,0,0,0,0,0 0,0,0,0,0,7,9"},
{8, "5,0,0,0,0,0,0,0 0,0,9,0,13,0,7,0 0,0,0,0,3,0,0,0 0,5,0,0,11,0,0,0 0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,1 0,0,11,0,0,0,3,0 13,9,7,0,0,0,1,0"},
{8, "0,0,0,0,0,0,0,0 0,3,9,5,0,0,0,0 0,0,0,13,0,0,0,0 0,3,0,0,9,0,0,0 0,0,0,0,7,13,0,0 0,0,0,0,0,0,0,0 0,7,5,0,0,0,11,0 0,0,1,11,1,0,0,0"},
{6, "0,0,11,5,0,0 11,7,0,0,7,0 9,0,0,0,0,0 0,0,0,3,0,0 0,0,0,1,0,0 3,1,9,0,0,5"},
{8, "9,0,0,1,5,0,0,0 0,1,0,0,0,0,0,0 0,7,0,0,0,9,0,0 0,0,0,0,0,5,0,0 0,0,0,0,0,3,0,0 0,0,0,0,0,0,0,0 0,3,7,0,0,0,0,0 0,0,0,0,0,0,0,0"},
{6, "0,0,5,0,0,0 0,3,0,0,1,0 0,0,0,0,0,0 0,0,0,0,9,0 0,1,0,7,0,0 0,5,0,9,7,3"},
{7, "0,0,0,0,0,0,1 0,5,0,0,0,0,9 0,0,0,0,0,0,3 0,5,3,0,0,0,7 0,0,0,0,0,0,0 0,1,9,0,0,0,0 0,0,0,0,0,0,7"},
{8, "0,0,0,3,0,0,3,11 0,1,0,0,0,0,0,0 0,0,1,15,0,9,7,0 0,5,0,0,0,0,0,0 0,0,13,0,0,0,9,0 7,0,0,0,5,0,0,0 0,15,0,0,0,13,11,0 0,0,0,0,0,0,0,0"},
{9, "0,0,0,0,0,0,0,0,0 0,0,0,5,0,0,0,9,0 0,0,0,0,0,0,0,0,0 7,5,9,13,0,0,1,0,0 13,0,11,0,0,0,0,0,0 1,0,0,0,0,0,0,0,0 0,0,11,0,0,0,0,0,0 0,0,0,0,3,0,0,7,3 0,0,0,0,0,0,0,0,0"},
{6, "5,3,0,0,0,0 0,0,0,0,0,3 0,0,0,0,0,5 0,1,7,0,0,0 0,0,0,0,0,9 9,0,0,1,0,7"},
{9, "0,0,0,13,3,5,1,7,13 0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0 0,0,0,11,0,9,0,7,0 0,0,0,3,0,0,0,0,0 0,0,0,0,0,0,0,0,0 0,0,5,0,0,11,9,0,0 0,0,0,0,1,0,0,0,0 0,0,0,0,0,0,0,0,0"},
{5, "5,0,3,0,3 1,0,0,0,0 0,0,0,1,0 0,0,0,7,0 7,5,0,0,0"},
{9, "0,0,0,0,0,0,0,11,5 0,5,0,0,0,0,0,0,0 0,0,0,0,11,0,0,0,0 0,0,0,0,0,0,0,7,0 0,15,0,7,0,0,0,1,0 0,0,0,9,0,0,0,0,0 3,0,0,0,0,13,0,0,0 0,0,0,9,0,0,0,1,0 0,0,0,3,15,13,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,3 0,0,0,0,0,0,7,0,0,0 0,0,0,0,0,0,1,0,0,0 5,0,0,11,0,0,0,0,0,0 9,0,0,0,0,9,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,3,0,0,0 0,0,0,0,0,7,0,0,0,0 0,0,0,5,0,0,0,0,0,0 1,11,0,0,0,0,0,0,0,0"},
{7, "0,0,0,0,0,0,3 3,5,0,0,0,5,1 1,7,0,0,11,9,0 0,9,11,7,0,0,0 0,0,0,0,0,0,0 0,0,0,0,0,0,0 0,0,0,0,0,0,0"},
{5, "0,0,1,3,7 0,0,5,0,0 0,0,9,0,0 1,5,0,3,0 9,0,0,7,0"},
{9, "0,0,0,0,0,0,0,0,0 0,5,1,0,0,0,0,9,0 3,0,0,0,13,7,0,0,0 0,0,0,0,0,0,0,0,0 0,1,0,9,5,11,0,0,0 0,0,0,0,0,0,0,0,0 13,0,0,0,0,0,0,0,0 0,11,0,0,0,0,0,7,0 0,0,0,3,0,0,0,0,0"},
{10, "7,0,0,0,0,0,0,0,0,0 1,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,5,0,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,3,0,0,7,0,0,0 9,0,0,0,0,0,0,0,0,0 3,0,0,0,9,0,1,0,0,0 5,0,0,0,0,0,0,0,0,0"},
{10, "0,0,0,0,0,0,0,0,0,0 3,5,0,0,0,0,0,0,7,0 9,1,0,0,9,11,0,0,0,0 0,0,0,7,0,0,0,0,0,0 0,0,0,0,0,0,5,0,0,0 0,0,0,0,0,0,1,0,0,0 0,0,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,3,0,0 0,11,0,0,0,0,0,0,0,0 0,0,0,0,0,0,0,0,0,0"},
{7, "0,0,0,0,0,0,0 0,0,0,0,0,0,0 0,0,1,11,0,3,5 0,0,0,1,0,0,7 0,0,0,5,11,0,9 0,3,0,7,0,0,0 0,0,0,9,0,0,0"},
{7, "13,0,0,9,0,0,0 0,0,0,5,0,7,3 0,0,0,11,0,0,7 13,9,0,0,0,0,0 5,0,0,0,0,11,0 1,0,0,0,0,1,0 3,0,0,0,0,0,0"},
{5, "0,0,0,0,0 0,0,3,7,5 0,0,7,0,1 0,0,0,0,0 0,0,5,3,1"},
{9, "0,0,0,3,0,0,13,0,0 0,1,0,0,17,0,0,3,13 0,0,0,0,0,0,0,0,0 0,0,0,0,0,7,0,11,0 5,9,0,0,0,1,0,0,0 0,0,5,0,0,0,0,11,0 0,0,0,0,0,0,0,17,0 0,9,0,0,0,0,0,0,7 0,0,0,0,0,0,15,0,15"},
{7, "5,3,0,0,0,0,0 0,0,0,0,0,0,0 0,9,7,0,7,0,0 0,11,0,0,0,5,0 0,0,0,1,0,9,0 0,11,0,0,0,1,0 0,0,0,3,0,0,0"},
{7, "0,3,11,0,0,0,0 0,0,0,0,0,0,0 0,0,0,0,0,0,11 3,0,0,1,0,0,0 7,0,0,0,0,0,0 5,9,0,0,1,9,0 0,0,0,0,5,7,0"},
{8, "0,0,0,0,0,0,0,0 0,1,0,0,0,0,13,0 0,0,0,0,3,0,3,0 7,0,1,13,5,0,0,0 0,0,9,0,9,0,0,0 0,0,5,11,0,0,7,0 0,0,0,0,0,0,0,0 11,0,0,0,0,0,0,0"},
{6, "0,0,0,0,0,5 5,0,0,0,1,0 7,0,9,0,0,0 9,0,0,13,7,0 13,0,0,0,3,1 11,0,0,11,0,3"},
{6, "3,7,1,0,0,0 0,0,0,3,1,0 0,7,0,0,0,0 0,0,0,0,5,0 0,5,0,0,0,0 0,0,0,9,0,9"},
{6, "9,1,0,3,9,0 0,0,3,0,7,0 0,0,7,0,1,0 0,0,0,0,0,0 0,5,0,0,5,0 0,0,0,0,0,0"},
{7, "0,0,9,7,0,0,3 0,1,11,1,5,0,0 0,0,0,0,0,0,0 0,0,0,0,0,0,0 0,0,11,0,0,0,3 0,0,0,0,0,0,7 0,0,0,9,0,0,5"},
{6, "7,0,0,0,0,0 0,0,7,3,1,0 0,0,0,0,0,0 0,0,0,0,0,0 0,5,0,3,0,0 0,0,0,1,0,5"},
{8, "0,0,0,0,0,0,0,0 0,0,0,0,0,1,3,0 0,1,0,0,0,7,0,0 0,0,0,3,0,0,0,0 0,7,11,0,0,11,13,0 0,5,9,0,0,9,0,0 13,0,0,0,0,0,0,0 5,0,0,0,0,0,0,0"},
{6, "0,0,0,0,0,0 1,0,0,0,3,0 0,0,5,9,7,0 0,5,0,0,0,0 0,3,0,0,7,0 9,0,0,1,0,0"},
{6, "7,1,3,5,0,9 0,0,0,11,5,0 0,0,0,0,0,0 7,0,0,3,11,0 9,0,0,0,1,0 0,0,0,0,0,0"},
{7, "0,0,0,0,0,0,0 9,5,1,0,0,0,0 0,0,3,13,0,0,0 0,0,0,7,0,0,9 0,0,11,0,0,0,1 0,0,0,0,0,0,0 5,3,11,0,0,7,13"},
{5, "0,0,0,3,0 0,5,0,1,0 0,0,0,5,0 0,0,0,1,0 3,0,0,0,0"},
{9, "0,7,3,17,0,0,0,0,0 0,1,0,0,0,0,0,13,0 7,0,0,0,1,0,0,17,0 0,0,0,0,13,0,0,15,0 0,11,0,0,0,0,0,0,0 0,0,3,11,0,0,0,0,0 0,0,0,0,9,5,0,0,0 0,5,0,0,0,0,9,15,0 0,0,0,0,0,0,0,0,0"},
{8, "0,0,0,0,0,0,0,7 0,3,0,11,1,0,0,0 0,0,0,0,7,1,0,0 0,0,5,0,11,0,0,0 0,0,9,0,0,0,5,0 0,0,0,0,0,0,9,0 0,0,0,0,0,0,3,0 0,0,0,0,0,0,0,0"},
{8, "15,0,0,0,0,0,0,1 0,0,0,0,0,5,0,0 0,0,3,9,0,0,0,0 0,0,0,0,11,0,15,0 5,0,0,7,13,0,1,0 3,0,0,0,0,0,0,0 0,0,0,0,0,0,13,0 11,7,0,0,9,0,0,0"},
{5, "0,0,0,0,3 0,1,0,0,7 0,0,0,0,5 0,0,0,5,7 3,1,0,0,0"},
{7, "0,0,0,7,0,0,0 5,7,0,9,0,0,0 0,0,5,0,1,0,0 0,11,1,0,9,0,0 0,0,3,0,0,3,0 0,0,0,0,0,11,0 0,0,0,0,0,0,0"},
{5, "0,0,0,0,7 7,0,9,3,1 9,0,0,0,0 0,0,0,5,0 3,5,0,0,1"},
{5, "0,0,0,0,7 0,3,0,0,0 0,1,0,0,0 0,5,3,0,0 5,1,0,0,7"}}
}}